# -*- coding: utf-8 -*-
#
#    TypeAtlas Character Set Data
#    Created in 2018-2021 by Milko Krachounov
#
#    This file is part of TypeAtlas. This file is computer-generated.
#
#    To the extent possible under law, Milko Krachunov has waived all copyright
#    and related or neighboring rights to TypeAtlas Character Set Data.
#    This software is distributed without any warranty.
#
#    You should have received a copy of the CC0 legalcode along with this
#    work.  If not, see <http://creativecommons.org/publicdomain/zero/1.0/>.
#

from typeatlas.charsets import add_encoding, charblocks
from typeatlas.charsets import UNICODE, UNICODE_SCRIPTS

# CHARS_ASCII = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f'


CHARS_ASCII = charblocks([(0x0, 0x7f)])



add_encoding('ascii', characters=CHARS_ASCII,
             scripts={'Latn': 52, 'Zyyy': 76},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=7)


add_encoding('big5', characters=None,
             scripts={'Grek': 48, 'Kana': 87, 'Zyyy': 334, 'Latn': 114, 'Hani': 13073, 'Bopo': 37, 'Cyrl': 56, 'Hira': 85},
             multibyte=True, fixed=False, unicode=False,
             charsize=None, maxbits=16)


add_encoding('big5hkscs', characters=None,
             scripts={'Grek': 48, 'Kana': 88, 'Zyyy': 397, 'Latn': 179, 'Hani': 17614, 'Bopo': 37, 'Cyrl': 66, 'Hira': 85},
             multibyte=True, fixed=False, unicode=False,
             charsize=None, maxbits=16)

# CHARS_CP037 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f\xa0¡¢£¤¥¦§¨©ª«¬\xad®¯°±²³´µ¶·¸¹º»¼½¾¿ÀÁÂÃÄÅÆÇÈÉÊËÌÍÎÏÐÑÒÓÔÕÖ×ØÙÚÛÜÝÞßàáâãäåæçèéêëìíîïðñòóôõö÷øùúûüýþÿ'


CHARS_CP037 = charblocks([(0x0, 0xff)])



add_encoding('cp037', characters=CHARS_CP037,
             scripts={'Latn': 116, 'Zyyy': 140},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_CP1006 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f\xa0\xad،؛؟۰۱۲۳۴۵۶۷۸۹ﭖﭘﭦﭨﭺﭼﮄﮊﮌﮒﮔﮞﮦﮨﮩﮪﮮﮰﹼﹽﺀﺁﺅﺉﺊﺋﺍﺎﺏﺑﺓﺕﺗﺙﺛﺝﺟﺡﺣﺥﺧﺩﺫﺭﺯﺱﺳﺵﺷﺹﺻﺽﺿﻁﻅﻉﻊﻋﻌﻍﻎﻏﻐﻑﻓﻕﻗﻙﻛﻝﻟﻠﻡﻣﻥﻧﻭﻱﻲﻳ'


CHARS_CP1006 = charblocks([(0x0, 0xa0), (0xad, 0xad), (0x60c, 0x60c), (0x61b, 0x61b), (0x61f, 0x61f), (0x6f0, 0x6f9), (0xfb56, 0xfb56), (0xfb58, 0xfb58), (0xfb66, 0xfb66), (0xfb68, 0xfb68), (0xfb7a, 0xfb7a), (0xfb7c, 0xfb7c), (0xfb84, 0xfb84), (0xfb8a, 0xfb8a), (0xfb8c, 0xfb8c), (0xfb92, 0xfb92), (0xfb94, 0xfb94), (0xfb9e, 0xfb9e), (0xfba6, 0xfba6), (0xfba8, 0xfbaa), (0xfbae, 0xfbae), (0xfbb0, 0xfbb0), (0xfe7c, 0xfe7d), (0xfe80, 0xfe81), (0xfe85, 0xfe85), (0xfe89, 0xfe8b), (0xfe8d, 0xfe8f), (0xfe91, 0xfe91), (0xfe93, 0xfe93), (0xfe95, 0xfe95), (0xfe97, 0xfe97), (0xfe99, 0xfe99), (0xfe9b, 0xfe9b), (0xfe9d, 0xfe9d), (0xfe9f, 0xfe9f), (0xfea1, 0xfea1), (0xfea3, 0xfea3), (0xfea5, 0xfea5), (0xfea7, 0xfea7), (0xfea9, 0xfea9), (0xfeab, 0xfeab), (0xfead, 0xfead), (0xfeaf, 0xfeaf), (0xfeb1, 0xfeb1), (0xfeb3, 0xfeb3), (0xfeb5, 0xfeb5), (0xfeb7, 0xfeb7), (0xfeb9, 0xfeb9), (0xfebb, 0xfebb), (0xfebd, 0xfebd), (0xfebf, 0xfebf), (0xfec1, 0xfec1), (0xfec5, 0xfec5), (0xfec9, 0xfed1), (0xfed3, 0xfed3), (0xfed5, 0xfed5), (0xfed7, 0xfed7), (0xfed9, 0xfed9), (0xfedb, 0xfedb), (0xfedd, 0xfedd), (0xfedf, 0xfee1), (0xfee3, 0xfee3), (0xfee5, 0xfee5), (0xfee7, 0xfee7), (0xfeed, 0xfeed), (0xfef1, 0xfef3)])



add_encoding('cp1006', characters=CHARS_CP1006,
             scripts={'Latn': 52, 'Arab': 90, 'Zyyy': 113},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_CP1026 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f\xa0¡¢£¤¥¦§¨©ª«¬\xad®¯°±²³´µ¶·¸¹º»¼½¾¿ÀÁÂÃÄÅÆÇÈÉÊËÌÍÎÏÑÒÓÔÕÖ×ØÙÚÛÜßàáâãäåæçèéêëìíîïñòóôõö÷øùúûüÿĞğİıŞş'


CHARS_CP1026 = charblocks([(0x0, 0xcf), (0xd1, 0xdc), (0xdf, 0xef), (0xf1, 0xfc), (0xff, 0xff), (0x11e, 0x11f), (0x130, 0x131), (0x15e, 0x15f)])



add_encoding('cp1026', characters=CHARS_CP1026,
             scripts={'Latn': 116, 'Zyyy': 140},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_CP1125 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0¤·ЁЄІЇАБВГДЕЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯабвгдежзийклмнопрстуфхцчшщъыьэюяёєіїҐґ№√─│┌┐└┘├┤┬┴┼═║╒╓╔╕╖╗╘╙╚╛╜╝╞╟╠╡╢╣╤╥╦╧╨╩╪╫╬▀▄█▌▐░▒▓■'


CHARS_CP1125 = charblocks([(0x0, 0x7f), (0xa0, 0xa0), (0xa4, 0xa4), (0xb7, 0xb7), (0x401, 0x401), (0x404, 0x404), (0x406, 0x407), (0x410, 0x44f), (0x451, 0x451), (0x454, 0x454), (0x456, 0x457), (0x490, 0x491), (0x2116, 0x2116), (0x221a, 0x221a), (0x2500, 0x2500), (0x2502, 0x2502), (0x250c, 0x250c), (0x2510, 0x2510), (0x2514, 0x2514), (0x2518, 0x2518), (0x251c, 0x251c), (0x2524, 0x2524), (0x252c, 0x252c), (0x2534, 0x2534), (0x253c, 0x253c), (0x2550, 0x256c), (0x2580, 0x2580), (0x2584, 0x2584), (0x2588, 0x2588), (0x258c, 0x258c), (0x2590, 0x2593), (0x25a0, 0x25a0)])



add_encoding('cp1125', characters=CHARS_CP1125,
             scripts={'Latn': 52, 'Zyyy': 130, 'Cyrl': 74},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_CP1140 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f\xa0¡¢£¥¦§¨©ª«¬\xad®¯°±²³´µ¶·¸¹º»¼½¾¿ÀÁÂÃÄÅÆÇÈÉÊËÌÍÎÏÐÑÒÓÔÕÖ×ØÙÚÛÜÝÞßàáâãäåæçèéêëìíîïðñòóôõö÷øùúûüýþÿ€'


CHARS_CP1140 = charblocks([(0x0, 0xa3), (0xa5, 0xff), (0x20ac, 0x20ac)])



add_encoding('cp1140', characters=CHARS_CP1140,
             scripts={'Latn': 116, 'Zyyy': 140},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_CP1250 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0¤¦§¨©«¬\xad®°±´µ¶·¸»ÁÂÄÇÉËÍÎÓÔÖ×ÚÜÝßáâäçéëíîóôö÷úüýĂăĄąĆćČčĎďĐđĘęĚěĹĺĽľŁłŃńŇňŐőŔŕŘřŚśŞşŠšŢţŤťŮůŰűŹźŻżŽžˇ˘˙˛˝–—‘’‚“”„†‡•…‰‹›€™'


CHARS_CP1250 = charblocks([(0x0, 0x7f), (0xa0, 0xa0), (0xa4, 0xa4), (0xa6, 0xa9), (0xab, 0xae), (0xb0, 0xb1), (0xb4, 0xb8), (0xbb, 0xbb), (0xc1, 0xc2), (0xc4, 0xc4), (0xc7, 0xc7), (0xc9, 0xc9), (0xcb, 0xcb), (0xcd, 0xce), (0xd3, 0xd4), (0xd6, 0xd7), (0xda, 0xda), (0xdc, 0xdd), (0xdf, 0xdf), (0xe1, 0xe2), (0xe4, 0xe4), (0xe7, 0xe7), (0xe9, 0xe9), (0xeb, 0xeb), (0xed, 0xee), (0xf3, 0xf4), (0xf6, 0xf7), (0xfa, 0xfa), (0xfc, 0xfd), (0x102, 0x107), (0x10c, 0x111), (0x118, 0x11b), (0x139, 0x13a), (0x13d, 0x13e), (0x141, 0x144), (0x147, 0x148), (0x150, 0x151), (0x154, 0x155), (0x158, 0x15b), (0x15e, 0x165), (0x16e, 0x171), (0x179, 0x17e), (0x2c7, 0x2c7), (0x2d8, 0x2d9), (0x2db, 0x2db), (0x2dd, 0x2dd), (0x2013, 0x2014), (0x2018, 0x201a), (0x201c, 0x201e), (0x2020, 0x2022), (0x2026, 0x2026), (0x2030, 0x2030), (0x2039, 0x203a), (0x20ac, 0x20ac), (0x2122, 0x2122)])



add_encoding('cp1250', characters=CHARS_CP1250,
             scripts={'Latn': 133, 'Zyyy': 118},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_CP1251 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0¤¦§©«¬\xad®°±µ¶·»ЁЂЃЄЅІЇЈЉЊЋЌЎЏАБВГДЕЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯабвгдежзийклмнопрстуфхцчшщъыьэюяёђѓєѕіїјљњћќўџҐґ–—‘’‚“”„†‡•…‰‹›€№™'


CHARS_CP1251 = charblocks([(0x0, 0x7f), (0xa0, 0xa0), (0xa4, 0xa4), (0xa6, 0xa7), (0xa9, 0xa9), (0xab, 0xae), (0xb0, 0xb1), (0xb5, 0xb7), (0xbb, 0xbb), (0x401, 0x40c), (0x40e, 0x44f), (0x451, 0x45c), (0x45e, 0x45f), (0x490, 0x491), (0x2013, 0x2014), (0x2018, 0x201a), (0x201c, 0x201e), (0x2020, 0x2022), (0x2026, 0x2026), (0x2030, 0x2030), (0x2039, 0x203a), (0x20ac, 0x20ac), (0x2116, 0x2116), (0x2122, 0x2122)])



add_encoding('cp1251', characters=CHARS_CP1251,
             scripts={'Latn': 52, 'Zyyy': 109, 'Cyrl': 94},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_CP1252 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0¡¢£¤¥¦§¨©ª«¬\xad®¯°±²³´µ¶·¸¹º»¼½¾¿ÀÁÂÃÄÅÆÇÈÉÊËÌÍÎÏÐÑÒÓÔÕÖ×ØÙÚÛÜÝÞßàáâãäåæçèéêëìíîïðñòóôõö÷øùúûüýþÿŒœŠšŸŽžƒˆ˜–—‘’‚“”„†‡•…‰‹›€™'


CHARS_CP1252 = charblocks([(0x0, 0x7f), (0xa0, 0xff), (0x152, 0x153), (0x160, 0x161), (0x178, 0x178), (0x17d, 0x17e), (0x192, 0x192), (0x2c6, 0x2c6), (0x2dc, 0x2dc), (0x2013, 0x2014), (0x2018, 0x201a), (0x201c, 0x201e), (0x2020, 0x2022), (0x2026, 0x2026), (0x2030, 0x2030), (0x2039, 0x203a), (0x20ac, 0x20ac), (0x2122, 0x2122)])



add_encoding('cp1252', characters=CHARS_CP1252,
             scripts={'Latn': 124, 'Zyyy': 127},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_CP1253 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0£¤¥¦§¨©«¬\xad®°±²³µ¶·»½ƒ΄΅ΆΈΉΊΌΎΏΐΑΒΓΔΕΖΗΘΙΚΛΜΝΞΟΠΡΣΤΥΦΧΨΩΪΫάέήίΰαβγδεζηθικλμνξοπρςστυφχψωϊϋόύώ–—―‘’‚“”„†‡•…‰‹›€™'


CHARS_CP1253 = charblocks([(0x0, 0x7f), (0xa0, 0xa0), (0xa3, 0xa9), (0xab, 0xae), (0xb0, 0xb3), (0xb5, 0xb7), (0xbb, 0xbb), (0xbd, 0xbd), (0x192, 0x192), (0x384, 0x386), (0x388, 0x38a), (0x38c, 0x38c), (0x38e, 0x3a1), (0x3a3, 0x3ce), (0x2013, 0x2015), (0x2018, 0x201a), (0x201c, 0x201e), (0x2020, 0x2022), (0x2026, 0x2026), (0x2030, 0x2030), (0x2039, 0x203a), (0x20ac, 0x20ac), (0x2122, 0x2122)])



add_encoding('cp1253', characters=CHARS_CP1253,
             scripts={'Latn': 53, 'Grek': 70, 'Zyyy': 116},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_CP1254 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0¡¢£¤¥¦§¨©ª«¬\xad®¯°±²³´µ¶·¸¹º»¼½¾¿ÀÁÂÃÄÅÆÇÈÉÊËÌÍÎÏÑÒÓÔÕÖ×ØÙÚÛÜßàáâãäåæçèéêëìíîïñòóôõö÷øùúûüÿĞğİıŒœŞşŠšŸƒˆ˜–—‘’‚“”„†‡•…‰‹›€™'


CHARS_CP1254 = charblocks([(0x0, 0x7f), (0xa0, 0xcf), (0xd1, 0xdc), (0xdf, 0xef), (0xf1, 0xfc), (0xff, 0xff), (0x11e, 0x11f), (0x130, 0x131), (0x152, 0x153), (0x15e, 0x161), (0x178, 0x178), (0x192, 0x192), (0x2c6, 0x2c6), (0x2dc, 0x2dc), (0x2013, 0x2014), (0x2018, 0x201a), (0x201c, 0x201e), (0x2020, 0x2022), (0x2026, 0x2026), (0x2030, 0x2030), (0x2039, 0x203a), (0x20ac, 0x20ac), (0x2122, 0x2122)])



add_encoding('cp1254', characters=CHARS_CP1254,
             scripts={'Latn': 122, 'Zyyy': 127},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_CP1255 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0¡¢£¥¦§¨©«¬\xad®¯°±²³´µ¶·¸¹»¼½¾¿×÷ƒˆ˜ְֱֲֳִֵֶַָֹֻּֽ־ֿ׀ׁׂ׃אבגדהוזחטיךכלםמןנסעףפץצקרשתװױײ׳״\u200e\u200f–—‘’‚“”„†‡•…‰‹›₪€™'


CHARS_CP1255 = charblocks([(0x0, 0x7f), (0xa0, 0xa3), (0xa5, 0xa9), (0xab, 0xb9), (0xbb, 0xbf), (0xd7, 0xd7), (0xf7, 0xf7), (0x192, 0x192), (0x2c6, 0x2c6), (0x2dc, 0x2dc), (0x5b0, 0x5b9), (0x5bb, 0x5c3), (0x5d0, 0x5ea), (0x5f0, 0x5f4), (0x200e, 0x200f), (0x2013, 0x2014), (0x2018, 0x201a), (0x201c, 0x201e), (0x2020, 0x2022), (0x2026, 0x2026), (0x2030, 0x2030), (0x2039, 0x203a), (0x20aa, 0x20aa), (0x20ac, 0x20ac), (0x2122, 0x2122)])



add_encoding('cp1255', characters=CHARS_CP1255,
             scripts={'Latn': 53, 'Hebr': 51, 'Zyyy': 129},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_CP1256 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0¢£¤¥¦§¨©«¬\xad®¯°±²³´µ¶·¸¹»¼½¾×àâçèéêëîïô÷ùûüŒœƒˆ،؛؟ءآأؤإئابةتثجحخدذرزسشصضطظعغـفقكلمنهوىيًٌٍَُِّْٹپچڈڑژکگںھہے\u200c\u200d\u200e\u200f–—‘’‚“”„†‡•…‰‹›€™'


CHARS_CP1256 = charblocks([(0x0, 0x7f), (0xa0, 0xa0), (0xa2, 0xa9), (0xab, 0xb9), (0xbb, 0xbe), (0xd7, 0xd7), (0xe0, 0xe0), (0xe2, 0xe2), (0xe7, 0xeb), (0xee, 0xef), (0xf4, 0xf4), (0xf7, 0xf7), (0xf9, 0xf9), (0xfb, 0xfc), (0x152, 0x153), (0x192, 0x192), (0x2c6, 0x2c6), (0x60c, 0x60c), (0x61b, 0x61b), (0x61f, 0x61f), (0x621, 0x63a), (0x640, 0x652), (0x679, 0x679), (0x67e, 0x67e), (0x686, 0x686), (0x688, 0x688), (0x691, 0x691), (0x698, 0x698), (0x6a9, 0x6a9), (0x6af, 0x6af), (0x6ba, 0x6ba), (0x6be, 0x6be), (0x6c1, 0x6c1), (0x6d2, 0x6d2), (0x200c, 0x200f), (0x2013, 0x2014), (0x2018, 0x201a), (0x201c, 0x201e), (0x2020, 0x2022), (0x2026, 0x2026), (0x2030, 0x2030), (0x2039, 0x203a), (0x20ac, 0x20ac), (0x2122, 0x2122)])



add_encoding('cp1256', characters=CHARS_CP1256,
             scripts={'Zinh': 10, 'Arab': 48, 'Latn': 68, 'Zyyy': 130},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_CP1257 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0¢£¤¦§¨©«¬\xad®¯°±²³´µ¶·¸¹»¼½¾ÄÅÆÉÓÕÖ×ØÜßäåæéóõö÷øüĀāĄąĆćČčĒēĖėĘęĢģĪīĮįĶķĻļŁłŃńŅņŌōŖŗŚśŠšŪūŲųŹźŻżŽžˇ˙˛–—‘’‚“”„†‡•…‰‹›€™'


CHARS_CP1257 = charblocks([(0x0, 0x7f), (0xa0, 0xa0), (0xa2, 0xa4), (0xa6, 0xa9), (0xab, 0xb9), (0xbb, 0xbe), (0xc4, 0xc6), (0xc9, 0xc9), (0xd3, 0xd3), (0xd5, 0xd8), (0xdc, 0xdc), (0xdf, 0xdf), (0xe4, 0xe6), (0xe9, 0xe9), (0xf3, 0xf3), (0xf5, 0xf8), (0xfc, 0xfc), (0x100, 0x101), (0x104, 0x107), (0x10c, 0x10d), (0x112, 0x113), (0x116, 0x119), (0x122, 0x123), (0x12a, 0x12b), (0x12e, 0x12f), (0x136, 0x137), (0x13b, 0x13c), (0x141, 0x146), (0x14c, 0x14d), (0x156, 0x157), (0x15a, 0x15b), (0x160, 0x161), (0x16a, 0x16b), (0x172, 0x173), (0x179, 0x17e), (0x2c7, 0x2c7), (0x2d9, 0x2d9), (0x2db, 0x2db), (0x2013, 0x2014), (0x2018, 0x201a), (0x201c, 0x201e), (0x2020, 0x2022), (0x2026, 0x2026), (0x2030, 0x2030), (0x2039, 0x203a), (0x20ac, 0x20ac), (0x2122, 0x2122)])



add_encoding('cp1257', characters=CHARS_CP1257,
             scripts={'Latn': 119, 'Zyyy': 125},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_CP1258 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0¡¢£¤¥¦§¨©ª«¬\xad®¯°±²³´µ¶·¸¹º»¼½¾¿ÀÁÂÄÅÆÇÈÉÊËÍÎÏÑÓÔÖ×ØÙÚÛÜßàáâäåæçèéêëíîïñóôö÷øùúûüÿĂăĐđŒœŸƒƠơƯưˆ˜̣̀́̃̉–—‘’‚“”„†‡•…‰‹›₫€™'


CHARS_CP1258 = charblocks([(0x0, 0x7f), (0xa0, 0xc2), (0xc4, 0xcb), (0xcd, 0xcf), (0xd1, 0xd1), (0xd3, 0xd4), (0xd6, 0xdc), (0xdf, 0xe2), (0xe4, 0xeb), (0xed, 0xef), (0xf1, 0xf1), (0xf3, 0xf4), (0xf6, 0xfc), (0xff, 0xff), (0x102, 0x103), (0x110, 0x111), (0x152, 0x153), (0x178, 0x178), (0x192, 0x192), (0x1a0, 0x1a1), (0x1af, 0x1b0), (0x2c6, 0x2c6), (0x2dc, 0x2dc), (0x300, 0x301), (0x303, 0x303), (0x309, 0x309), (0x323, 0x323), (0x2013, 0x2014), (0x2018, 0x201a), (0x201c, 0x201e), (0x2020, 0x2022), (0x2026, 0x2026), (0x2030, 0x2030), (0x2039, 0x203a), (0x20ab, 0x20ac), (0x2122, 0x2122)])



add_encoding('cp1258', characters=CHARS_CP1258,
             scripts={'Zinh': 5, 'Latn': 114, 'Zyyy': 128},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_CP273 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f\xa0¡¢£¤¥¦§¨©ª«¬\xad®°±²³´µ¶·¸¹º»¼½¾¿ÀÁÂÃÄÅÆÇÈÉÊËÌÍÎÏÐÑÒÓÔÕÖ×ØÙÚÛÜÝÞßàáâãäåæçèéêëìíîïðñòóôõö÷øùúûüýþÿ‾'


CHARS_CP273 = charblocks([(0x0, 0xae), (0xb0, 0xff), (0x203e, 0x203e)])



add_encoding('cp273', characters=CHARS_CP273,
             scripts={'Latn': 116, 'Zyyy': 140},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_CP424 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f\xa0¢£¤¥¦§¨©«¬\xad®¯°±²³´µ¶·¸¹»¼½¾×÷אבגדהוזחטיךכלםמןנסעףפץצקרשת‗'


CHARS_CP424 = charblocks([(0x0, 0xa0), (0xa2, 0xa9), (0xab, 0xb9), (0xbb, 0xbe), (0xd7, 0xd7), (0xf7, 0xf7), (0x5d0, 0x5ea), (0x2017, 0x2017)])



add_encoding('cp424', characters=CHARS_CP424,
             scripts={'Latn': 52, 'Hebr': 27, 'Zyyy': 139},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_CP437 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0¡¢£¥ª«¬°±²µ·º»¼½¿ÄÅÆÇÉÑÖÜßàáâäåæçèéêëìíîïñòóôö÷ùúûüÿƒΓΘΣΦΩαδεπστφⁿ₧∙√∞∩≈≡≤≥⌐⌠⌡─│┌┐└┘├┤┬┴┼═║╒╓╔╕╖╗╘╙╚╛╜╝╞╟╠╡╢╣╤╥╦╧╨╩╪╫╬▀▄█▌▐░▒▓■'


CHARS_CP437 = charblocks([(0x0, 0x7f), (0xa0, 0xa3), (0xa5, 0xa5), (0xaa, 0xac), (0xb0, 0xb2), (0xb5, 0xb5), (0xb7, 0xb7), (0xba, 0xbd), (0xbf, 0xbf), (0xc4, 0xc7), (0xc9, 0xc9), (0xd1, 0xd1), (0xd6, 0xd6), (0xdc, 0xdc), (0xdf, 0xe2), (0xe4, 0xef), (0xf1, 0xf4), (0xf6, 0xf7), (0xf9, 0xfc), (0xff, 0xff), (0x192, 0x192), (0x393, 0x393), (0x398, 0x398), (0x3a3, 0x3a3), (0x3a6, 0x3a6), (0x3a9, 0x3a9), (0x3b1, 0x3b1), (0x3b4, 0x3b5), (0x3c0, 0x3c0), (0x3c3, 0x3c4), (0x3c6, 0x3c6), (0x207f, 0x207f), (0x20a7, 0x20a7), (0x2219, 0x221a), (0x221e, 0x221e), (0x2229, 0x2229), (0x2248, 0x2248), (0x2261, 0x2261), (0x2264, 0x2265), (0x2310, 0x2310), (0x2320, 0x2321), (0x2500, 0x2500), (0x2502, 0x2502), (0x250c, 0x250c), (0x2510, 0x2510), (0x2514, 0x2514), (0x2518, 0x2518), (0x251c, 0x251c), (0x2524, 0x2524), (0x252c, 0x252c), (0x2534, 0x2534), (0x253c, 0x253c), (0x2550, 0x256c), (0x2580, 0x2580), (0x2584, 0x2584), (0x2588, 0x2588), (0x258c, 0x258c), (0x2590, 0x2593), (0x25a0, 0x25a0)])



add_encoding('cp437', characters=CHARS_CP437,
             scripts={'Latn': 90, 'Grek': 12, 'Zyyy': 154},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)


add_encoding('cp500', characters=CHARS_CP037,
             scripts={'Latn': 116, 'Zyyy': 140},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_CP720 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\x80\x81\x84\x86\x8d\x8e\x8f\x90\xa0£¤«°²µ·»àâçèéêëîïôùûءآأؤإئابةتثجحخدذرزسشصضطظعغـفقكلمنهوىيًٌٍَُِّْⁿ∙√≈≡─│┌┐└┘├┤┬┴┼═║╒╓╔╕╖╗╘╙╚╛╜╝╞╟╠╡╢╣╤╥╦╧╨╩╪╫╬▀▄█▌▐░▒▓■'


CHARS_CP720 = charblocks([(0x0, 0x81), (0x84, 0x84), (0x86, 0x86), (0x8d, 0x90), (0xa0, 0xa0), (0xa3, 0xa4), (0xab, 0xab), (0xb0, 0xb0), (0xb2, 0xb2), (0xb5, 0xb5), (0xb7, 0xb7), (0xbb, 0xbb), (0xe0, 0xe0), (0xe2, 0xe2), (0xe7, 0xeb), (0xee, 0xef), (0xf4, 0xf4), (0xf9, 0xf9), (0xfb, 0xfb), (0x621, 0x63a), (0x640, 0x652), (0x207f, 0x207f), (0x2219, 0x221a), (0x2248, 0x2248), (0x2261, 0x2261), (0x2500, 0x2500), (0x2502, 0x2502), (0x250c, 0x250c), (0x2510, 0x2510), (0x2514, 0x2514), (0x2518, 0x2518), (0x251c, 0x251c), (0x2524, 0x2524), (0x252c, 0x252c), (0x2534, 0x2534), (0x253c, 0x253c), (0x2550, 0x256c), (0x2580, 0x2580), (0x2584, 0x2584), (0x2588, 0x2588), (0x258c, 0x258c), (0x2590, 0x2593), (0x25a0, 0x25a0)])



add_encoding('cp720', characters=CHARS_CP720,
             scripts={'Zinh': 8, 'Arab': 36, 'Latn': 65, 'Zyyy': 147},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_CP737 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0°±²·÷ΆΈΉΊΌΎΏΑΒΓΔΕΖΗΘΙΚΛΜΝΞΟΠΡΣΤΥΦΧΨΩΪΫάέήίαβγδεζηθικλμνξοπρςστυφχψωϊϋόύώⁿ∙√≈≤≥─│┌┐└┘├┤┬┴┼═║╒╓╔╕╖╗╘╙╚╛╜╝╞╟╠╡╢╣╤╥╦╧╨╩╪╫╬▀▄█▌▐░▒▓■'


CHARS_CP737 = charblocks([(0x0, 0x7f), (0xa0, 0xa0), (0xb0, 0xb2), (0xb7, 0xb7), (0xf7, 0xf7), (0x386, 0x386), (0x388, 0x38a), (0x38c, 0x38c), (0x38e, 0x38f), (0x391, 0x3a1), (0x3a3, 0x3af), (0x3b1, 0x3ce), (0x207f, 0x207f), (0x2219, 0x221a), (0x2248, 0x2248), (0x2264, 0x2265), (0x2500, 0x2500), (0x2502, 0x2502), (0x250c, 0x250c), (0x2510, 0x2510), (0x2514, 0x2514), (0x2518, 0x2518), (0x251c, 0x251c), (0x2524, 0x2524), (0x252c, 0x252c), (0x2534, 0x2534), (0x253c, 0x253c), (0x2550, 0x256c), (0x2580, 0x2580), (0x2584, 0x2584), (0x2588, 0x2588), (0x258c, 0x258c), (0x2590, 0x2593), (0x25a0, 0x25a0)])



add_encoding('cp737', characters=CHARS_CP737,
             scripts={'Latn': 53, 'Grek': 67, 'Zyyy': 136},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_CP775 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0¢£¤¦§©«¬\xad®°±²³µ¶·¹»¼½¾ÄÅÆÉÓÕÖ×ØÜßäåæéóõö÷øüĀāĄąĆćČčĒēĖėĘęĢģĪīĮįĶķĻļŁłŃńŅņŌōŖŗŚśŠšŪūŲųŹźŻżŽž’“”„∙─│┌┐└┘├┤┬┴┼═║╔╗╚╝╠╣╦╩╬▀▄█▌▐░▒▓■'


CHARS_CP775 = charblocks([(0x0, 0x7f), (0xa0, 0xa0), (0xa2, 0xa4), (0xa6, 0xa7), (0xa9, 0xa9), (0xab, 0xae), (0xb0, 0xb3), (0xb5, 0xb7), (0xb9, 0xb9), (0xbb, 0xbe), (0xc4, 0xc6), (0xc9, 0xc9), (0xd3, 0xd3), (0xd5, 0xd8), (0xdc, 0xdc), (0xdf, 0xdf), (0xe4, 0xe6), (0xe9, 0xe9), (0xf3, 0xf3), (0xf5, 0xf8), (0xfc, 0xfc), (0x100, 0x101), (0x104, 0x107), (0x10c, 0x10d), (0x112, 0x113), (0x116, 0x119), (0x122, 0x123), (0x12a, 0x12b), (0x12e, 0x12f), (0x136, 0x137), (0x13b, 0x13c), (0x141, 0x146), (0x14c, 0x14d), (0x156, 0x157), (0x15a, 0x15b), (0x160, 0x161), (0x16a, 0x16b), (0x172, 0x173), (0x179, 0x17e), (0x2019, 0x2019), (0x201c, 0x201e), (0x2219, 0x2219), (0x2500, 0x2500), (0x2502, 0x2502), (0x250c, 0x250c), (0x2510, 0x2510), (0x2514, 0x2514), (0x2518, 0x2518), (0x251c, 0x251c), (0x2524, 0x2524), (0x252c, 0x252c), (0x2534, 0x2534), (0x253c, 0x253c), (0x2550, 0x2551), (0x2554, 0x2554), (0x2557, 0x2557), (0x255a, 0x255a), (0x255d, 0x255d), (0x2560, 0x2560), (0x2563, 0x2563), (0x2566, 0x2566), (0x2569, 0x2569), (0x256c, 0x256c), (0x2580, 0x2580), (0x2584, 0x2584), (0x2588, 0x2588), (0x258c, 0x258c), (0x2590, 0x2593), (0x25a0, 0x25a0)])



add_encoding('cp775', characters=CHARS_CP775,
             scripts={'Latn': 119, 'Zyyy': 137},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_CP850 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0¡¢£¤¥¦§¨©ª«¬\xad®¯°±²³´µ¶·¸¹º»¼½¾¿ÀÁÂÃÄÅÆÇÈÉÊËÌÍÎÏÐÑÒÓÔÕÖ×ØÙÚÛÜÝÞßàáâãäåæçèéêëìíîïðñòóôõö÷øùúûüýþÿıƒ‗─│┌┐└┘├┤┬┴┼═║╔╗╚╝╠╣╦╩╬▀▄█░▒▓■'


CHARS_CP850 = charblocks([(0x0, 0x7f), (0xa0, 0xff), (0x131, 0x131), (0x192, 0x192), (0x2017, 0x2017), (0x2500, 0x2500), (0x2502, 0x2502), (0x250c, 0x250c), (0x2510, 0x2510), (0x2514, 0x2514), (0x2518, 0x2518), (0x251c, 0x251c), (0x2524, 0x2524), (0x252c, 0x252c), (0x2534, 0x2534), (0x253c, 0x253c), (0x2550, 0x2551), (0x2554, 0x2554), (0x2557, 0x2557), (0x255a, 0x255a), (0x255d, 0x255d), (0x2560, 0x2560), (0x2563, 0x2563), (0x2566, 0x2566), (0x2569, 0x2569), (0x256c, 0x256c), (0x2580, 0x2580), (0x2584, 0x2584), (0x2588, 0x2588), (0x2591, 0x2593), (0x25a0, 0x25a0)])



add_encoding('cp850', characters=CHARS_CP850,
             scripts={'Latn': 118, 'Zyyy': 138},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_CP852 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0¤§¨«¬\xad°´¸»ÁÂÄÇÉËÍÎÓÔÖ×ÚÜÝßáâäçéëíîóôö÷úüýĂăĄąĆćČčĎďĐđĘęĚěĹĺĽľŁłŃńŇňŐőŔŕŘřŚśŞşŠšŢţŤťŮůŰűŹźŻżŽžˇ˘˙˛˝─│┌┐└┘├┤┬┴┼═║╔╗╚╝╠╣╦╩╬▀▄█░▒▓■'


CHARS_CP852 = charblocks([(0x0, 0x7f), (0xa0, 0xa0), (0xa4, 0xa4), (0xa7, 0xa8), (0xab, 0xad), (0xb0, 0xb0), (0xb4, 0xb4), (0xb8, 0xb8), (0xbb, 0xbb), (0xc1, 0xc2), (0xc4, 0xc4), (0xc7, 0xc7), (0xc9, 0xc9), (0xcb, 0xcb), (0xcd, 0xce), (0xd3, 0xd4), (0xd6, 0xd7), (0xda, 0xda), (0xdc, 0xdd), (0xdf, 0xdf), (0xe1, 0xe2), (0xe4, 0xe4), (0xe7, 0xe7), (0xe9, 0xe9), (0xeb, 0xeb), (0xed, 0xee), (0xf3, 0xf4), (0xf6, 0xf7), (0xfa, 0xfa), (0xfc, 0xfd), (0x102, 0x107), (0x10c, 0x111), (0x118, 0x11b), (0x139, 0x13a), (0x13d, 0x13e), (0x141, 0x144), (0x147, 0x148), (0x150, 0x151), (0x154, 0x155), (0x158, 0x15b), (0x15e, 0x165), (0x16e, 0x171), (0x179, 0x17e), (0x2c7, 0x2c7), (0x2d8, 0x2d9), (0x2db, 0x2db), (0x2dd, 0x2dd), (0x2500, 0x2500), (0x2502, 0x2502), (0x250c, 0x250c), (0x2510, 0x2510), (0x2514, 0x2514), (0x2518, 0x2518), (0x251c, 0x251c), (0x2524, 0x2524), (0x252c, 0x252c), (0x2534, 0x2534), (0x253c, 0x253c), (0x2550, 0x2551), (0x2554, 0x2554), (0x2557, 0x2557), (0x255a, 0x255a), (0x255d, 0x255d), (0x2560, 0x2560), (0x2563, 0x2563), (0x2566, 0x2566), (0x2569, 0x2569), (0x256c, 0x256c), (0x2580, 0x2580), (0x2584, 0x2584), (0x2588, 0x2588), (0x2591, 0x2593), (0x25a0, 0x25a0)])



add_encoding('cp852', characters=CHARS_CP852,
             scripts={'Latn': 133, 'Zyyy': 123},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_CP855 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0¤§«\xad»ЁЂЃЄЅІЇЈЉЊЋЌЎЏАБВГДЕЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯабвгдежзийклмнопрстуфхцчшщъыьэюяёђѓєѕіїјљњћќўџ№─│┌┐└┘├┤┬┴┼═║╔╗╚╝╠╣╦╩╬▀▄█░▒▓■'


CHARS_CP855 = charblocks([(0x0, 0x7f), (0xa0, 0xa0), (0xa4, 0xa4), (0xa7, 0xa7), (0xab, 0xab), (0xad, 0xad), (0xbb, 0xbb), (0x401, 0x40c), (0x40e, 0x44f), (0x451, 0x45c), (0x45e, 0x45f), (0x2116, 0x2116), (0x2500, 0x2500), (0x2502, 0x2502), (0x250c, 0x250c), (0x2510, 0x2510), (0x2514, 0x2514), (0x2518, 0x2518), (0x251c, 0x251c), (0x2524, 0x2524), (0x252c, 0x252c), (0x2534, 0x2534), (0x253c, 0x253c), (0x2550, 0x2551), (0x2554, 0x2554), (0x2557, 0x2557), (0x255a, 0x255a), (0x255d, 0x255d), (0x2560, 0x2560), (0x2563, 0x2563), (0x2566, 0x2566), (0x2569, 0x2569), (0x256c, 0x256c), (0x2580, 0x2580), (0x2584, 0x2584), (0x2588, 0x2588), (0x2591, 0x2593), (0x25a0, 0x25a0)])



add_encoding('cp855', characters=CHARS_CP855,
             scripts={'Latn': 52, 'Zyyy': 112, 'Cyrl': 92},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_CP856 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0¢£¤¥¦§¨©«¬\xad®¯°±²³´µ¶·¸¹»¼½¾×÷אבגדהוזחטיךכלםמןנסעףפץצקרשת‗─│┌┐└┘├┤┬┴┼═║╔╗╚╝╠╣╦╩╬▀▄█░▒▓■'


CHARS_CP856 = charblocks([(0x0, 0x7f), (0xa0, 0xa0), (0xa2, 0xa9), (0xab, 0xb9), (0xbb, 0xbe), (0xd7, 0xd7), (0xf7, 0xf7), (0x5d0, 0x5ea), (0x2017, 0x2017), (0x2500, 0x2500), (0x2502, 0x2502), (0x250c, 0x250c), (0x2510, 0x2510), (0x2514, 0x2514), (0x2518, 0x2518), (0x251c, 0x251c), (0x2524, 0x2524), (0x252c, 0x252c), (0x2534, 0x2534), (0x253c, 0x253c), (0x2550, 0x2551), (0x2554, 0x2554), (0x2557, 0x2557), (0x255a, 0x255a), (0x255d, 0x255d), (0x2560, 0x2560), (0x2563, 0x2563), (0x2566, 0x2566), (0x2569, 0x2569), (0x256c, 0x256c), (0x2580, 0x2580), (0x2584, 0x2584), (0x2588, 0x2588), (0x2591, 0x2593), (0x25a0, 0x25a0)])



add_encoding('cp856', characters=CHARS_CP856,
             scripts={'Latn': 52, 'Hebr': 27, 'Zyyy': 136},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_CP857 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0¡¢£¤¥¦§¨©ª«¬\xad®¯°±²³´µ¶·¸¹º»¼½¾¿ÀÁÂÃÄÅÆÇÈÉÊËÌÍÎÏÑÒÓÔÕÖ×ØÙÚÛÜßàáâãäåæçèéêëìíîïñòóôõö÷øùúûüÿĞğİıŞş─│┌┐└┘├┤┬┴┼═║╔╗╚╝╠╣╦╩╬▀▄█░▒▓■'


CHARS_CP857 = charblocks([(0x0, 0x7f), (0xa0, 0xcf), (0xd1, 0xdc), (0xdf, 0xef), (0xf1, 0xfc), (0xff, 0xff), (0x11e, 0x11f), (0x130, 0x131), (0x15e, 0x15f), (0x2500, 0x2500), (0x2502, 0x2502), (0x250c, 0x250c), (0x2510, 0x2510), (0x2514, 0x2514), (0x2518, 0x2518), (0x251c, 0x251c), (0x2524, 0x2524), (0x252c, 0x252c), (0x2534, 0x2534), (0x253c, 0x253c), (0x2550, 0x2551), (0x2554, 0x2554), (0x2557, 0x2557), (0x255a, 0x255a), (0x255d, 0x255d), (0x2560, 0x2560), (0x2563, 0x2563), (0x2566, 0x2566), (0x2569, 0x2569), (0x256c, 0x256c), (0x2580, 0x2580), (0x2584, 0x2584), (0x2588, 0x2588), (0x2591, 0x2593), (0x25a0, 0x25a0)])



add_encoding('cp857', characters=CHARS_CP857,
             scripts={'Latn': 116, 'Zyyy': 137},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_CP858 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0¡¢£¤¥¦§¨©ª«¬\xad®¯°±²³´µ¶·¸¹º»¼½¾¿ÀÁÂÃÄÅÆÇÈÉÊËÌÍÎÏÐÑÒÓÔÕÖ×ØÙÚÛÜÝÞßàáâãäåæçèéêëìíîïðñòóôõö÷øùúûüýþÿƒ‗€─│┌┐└┘├┤┬┴┼═║╔╗╚╝╠╣╦╩╬▀▄█░▒▓■'


CHARS_CP858 = charblocks([(0x0, 0x7f), (0xa0, 0xff), (0x192, 0x192), (0x2017, 0x2017), (0x20ac, 0x20ac), (0x2500, 0x2500), (0x2502, 0x2502), (0x250c, 0x250c), (0x2510, 0x2510), (0x2514, 0x2514), (0x2518, 0x2518), (0x251c, 0x251c), (0x2524, 0x2524), (0x252c, 0x252c), (0x2534, 0x2534), (0x253c, 0x253c), (0x2550, 0x2551), (0x2554, 0x2554), (0x2557, 0x2557), (0x255a, 0x255a), (0x255d, 0x255d), (0x2560, 0x2560), (0x2563, 0x2563), (0x2566, 0x2566), (0x2569, 0x2569), (0x256c, 0x256c), (0x2580, 0x2580), (0x2584, 0x2584), (0x2588, 0x2588), (0x2591, 0x2593), (0x25a0, 0x25a0)])



add_encoding('cp858', characters=CHARS_CP858,
             scripts={'Latn': 117, 'Zyyy': 139},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_CP860 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0¡¢£ª«¬°±²µ·º»¼½¿ÀÁÂÃÇÈÉÊÌÍÑÒÓÔÕÙÚÜßàáâãçèéêìíñòóôõ÷ùúüΓΘΣΦΩαδεπστφⁿ₧∙√∞∩≈≡≤≥⌠⌡─│┌┐└┘├┤┬┴┼═║╒╓╔╕╖╗╘╙╚╛╜╝╞╟╠╡╢╣╤╥╦╧╨╩╪╫╬▀▄█▌▐░▒▓■'


CHARS_CP860 = charblocks([(0x0, 0x7f), (0xa0, 0xa3), (0xaa, 0xac), (0xb0, 0xb2), (0xb5, 0xb5), (0xb7, 0xb7), (0xba, 0xbd), (0xbf, 0xc3), (0xc7, 0xca), (0xcc, 0xcd), (0xd1, 0xd5), (0xd9, 0xda), (0xdc, 0xdc), (0xdf, 0xe3), (0xe7, 0xea), (0xec, 0xed), (0xf1, 0xf5), (0xf7, 0xf7), (0xf9, 0xfa), (0xfc, 0xfc), (0x393, 0x393), (0x398, 0x398), (0x3a3, 0x3a3), (0x3a6, 0x3a6), (0x3a9, 0x3a9), (0x3b1, 0x3b1), (0x3b4, 0x3b5), (0x3c0, 0x3c0), (0x3c3, 0x3c4), (0x3c6, 0x3c6), (0x207f, 0x207f), (0x20a7, 0x20a7), (0x2219, 0x221a), (0x221e, 0x221e), (0x2229, 0x2229), (0x2248, 0x2248), (0x2261, 0x2261), (0x2264, 0x2265), (0x2320, 0x2321), (0x2500, 0x2500), (0x2502, 0x2502), (0x250c, 0x250c), (0x2510, 0x2510), (0x2514, 0x2514), (0x2518, 0x2518), (0x251c, 0x251c), (0x2524, 0x2524), (0x252c, 0x252c), (0x2534, 0x2534), (0x253c, 0x253c), (0x2550, 0x256c), (0x2580, 0x2580), (0x2584, 0x2584), (0x2588, 0x2588), (0x258c, 0x258c), (0x2590, 0x2593), (0x25a0, 0x25a0)])



add_encoding('cp860', characters=CHARS_CP860,
             scripts={'Latn': 92, 'Grek': 12, 'Zyyy': 152},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_CP861 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0¡£«¬°±²µ·»¼½¿ÁÄÅÆÇÉÍÐÓÖØÚÜÝÞßàáâäåæçèéêëíðóôö÷øúûüýþƒΓΘΣΦΩαδεπστφⁿ₧∙√∞∩≈≡≤≥⌐⌠⌡─│┌┐└┘├┤┬┴┼═║╒╓╔╕╖╗╘╙╚╛╜╝╞╟╠╡╢╣╤╥╦╧╨╩╪╫╬▀▄█▌▐░▒▓■'


CHARS_CP861 = charblocks([(0x0, 0x7f), (0xa0, 0xa1), (0xa3, 0xa3), (0xab, 0xac), (0xb0, 0xb2), (0xb5, 0xb5), (0xb7, 0xb7), (0xbb, 0xbd), (0xbf, 0xbf), (0xc1, 0xc1), (0xc4, 0xc7), (0xc9, 0xc9), (0xcd, 0xcd), (0xd0, 0xd0), (0xd3, 0xd3), (0xd6, 0xd6), (0xd8, 0xd8), (0xda, 0xda), (0xdc, 0xe2), (0xe4, 0xeb), (0xed, 0xed), (0xf0, 0xf0), (0xf3, 0xf4), (0xf6, 0xf8), (0xfa, 0xfe), (0x192, 0x192), (0x393, 0x393), (0x398, 0x398), (0x3a3, 0x3a3), (0x3a6, 0x3a6), (0x3a9, 0x3a9), (0x3b1, 0x3b1), (0x3b4, 0x3b5), (0x3c0, 0x3c0), (0x3c3, 0x3c4), (0x3c6, 0x3c6), (0x207f, 0x207f), (0x20a7, 0x20a7), (0x2219, 0x221a), (0x221e, 0x221e), (0x2229, 0x2229), (0x2248, 0x2248), (0x2261, 0x2261), (0x2264, 0x2265), (0x2310, 0x2310), (0x2320, 0x2321), (0x2500, 0x2500), (0x2502, 0x2502), (0x250c, 0x250c), (0x2510, 0x2510), (0x2514, 0x2514), (0x2518, 0x2518), (0x251c, 0x251c), (0x2524, 0x2524), (0x252c, 0x252c), (0x2534, 0x2534), (0x253c, 0x253c), (0x2550, 0x256c), (0x2580, 0x2580), (0x2584, 0x2584), (0x2588, 0x2588), (0x258c, 0x258c), (0x2590, 0x2593), (0x25a0, 0x25a0)])



add_encoding('cp861', characters=CHARS_CP861,
             scripts={'Latn': 92, 'Grek': 12, 'Zyyy': 152},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_CP862 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0¡¢£¥ª«¬°±²µ·º»¼½¿Ñßáíñó÷úƒΓΘΣΦΩαδεπστφאבגדהוזחטיךכלםמןנסעףפץצקרשתⁿ₧∙√∞∩≈≡≤≥⌐⌠⌡─│┌┐└┘├┤┬┴┼═║╒╓╔╕╖╗╘╙╚╛╜╝╞╟╠╡╢╣╤╥╦╧╨╩╪╫╬▀▄█▌▐░▒▓■'


CHARS_CP862 = charblocks([(0x0, 0x7f), (0xa0, 0xa3), (0xa5, 0xa5), (0xaa, 0xac), (0xb0, 0xb2), (0xb5, 0xb5), (0xb7, 0xb7), (0xba, 0xbd), (0xbf, 0xbf), (0xd1, 0xd1), (0xdf, 0xdf), (0xe1, 0xe1), (0xed, 0xed), (0xf1, 0xf1), (0xf3, 0xf3), (0xf7, 0xf7), (0xfa, 0xfa), (0x192, 0x192), (0x393, 0x393), (0x398, 0x398), (0x3a3, 0x3a3), (0x3a6, 0x3a6), (0x3a9, 0x3a9), (0x3b1, 0x3b1), (0x3b4, 0x3b5), (0x3c0, 0x3c0), (0x3c3, 0x3c4), (0x3c6, 0x3c6), (0x5d0, 0x5ea), (0x207f, 0x207f), (0x20a7, 0x20a7), (0x2219, 0x221a), (0x221e, 0x221e), (0x2229, 0x2229), (0x2248, 0x2248), (0x2261, 0x2261), (0x2264, 0x2265), (0x2310, 0x2310), (0x2320, 0x2321), (0x2500, 0x2500), (0x2502, 0x2502), (0x250c, 0x250c), (0x2510, 0x2510), (0x2514, 0x2514), (0x2518, 0x2518), (0x251c, 0x251c), (0x2524, 0x2524), (0x252c, 0x252c), (0x2534, 0x2534), (0x253c, 0x253c), (0x2550, 0x256c), (0x2580, 0x2580), (0x2584, 0x2584), (0x2588, 0x2588), (0x258c, 0x258c), (0x2590, 0x2593), (0x25a0, 0x25a0)])



add_encoding('cp862', characters=CHARS_CP862,
             scripts={'Grek': 12, 'Latn': 63, 'Hebr': 27, 'Zyyy': 154},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_CP863 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0¢£¤¦§¨«¬¯°±²³´µ¶·¸»¼½¾ÀÂÇÈÉÊËÎÏÔÙÛÜßàâçèéêëîïóô÷ùúûüƒΓΘΣΦΩαδεπστφ‗ⁿ∙√∞∩≈≡≤≥⌐⌠⌡─│┌┐└┘├┤┬┴┼═║╒╓╔╕╖╗╘╙╚╛╜╝╞╟╠╡╢╣╤╥╦╧╨╩╪╫╬▀▄█▌▐░▒▓■'


CHARS_CP863 = charblocks([(0x0, 0x7f), (0xa0, 0xa0), (0xa2, 0xa4), (0xa6, 0xa8), (0xab, 0xac), (0xaf, 0xb8), (0xbb, 0xbe), (0xc0, 0xc0), (0xc2, 0xc2), (0xc7, 0xcb), (0xce, 0xcf), (0xd4, 0xd4), (0xd9, 0xd9), (0xdb, 0xdc), (0xdf, 0xe0), (0xe2, 0xe2), (0xe7, 0xeb), (0xee, 0xef), (0xf3, 0xf4), (0xf7, 0xf7), (0xf9, 0xfc), (0x192, 0x192), (0x393, 0x393), (0x398, 0x398), (0x3a3, 0x3a3), (0x3a6, 0x3a6), (0x3a9, 0x3a9), (0x3b1, 0x3b1), (0x3b4, 0x3b5), (0x3c0, 0x3c0), (0x3c3, 0x3c4), (0x3c6, 0x3c6), (0x2017, 0x2017), (0x207f, 0x207f), (0x2219, 0x221a), (0x221e, 0x221e), (0x2229, 0x2229), (0x2248, 0x2248), (0x2261, 0x2261), (0x2264, 0x2265), (0x2310, 0x2310), (0x2320, 0x2321), (0x2500, 0x2500), (0x2502, 0x2502), (0x250c, 0x250c), (0x2510, 0x2510), (0x2514, 0x2514), (0x2518, 0x2518), (0x251c, 0x251c), (0x2524, 0x2524), (0x252c, 0x252c), (0x2534, 0x2534), (0x253c, 0x253c), (0x2550, 0x256c), (0x2580, 0x2580), (0x2584, 0x2584), (0x2588, 0x2588), (0x258c, 0x258c), (0x2590, 0x2593), (0x25a0, 0x25a0)])



add_encoding('cp863', characters=CHARS_CP863,
             scripts={'Latn': 83, 'Grek': 12, 'Zyyy': 161},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_CP864 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0¢£¤¦«¬\xad°±·»¼½×÷βφ،؛؟ـّ٠١٢٣٤٥٦٧٨٩٪∙√∞≈─│┌┐└┘├┤┬┴┼▒■ﹽﺀﺁﺂﺃﺄﺅﺋﺍﺎﺏﺑﺓﺕﺗﺙﺛﺝﺟﺡﺣﺥﺧﺩﺫﺭﺯﺱﺳﺵﺷﺹﺻﺽﺿﻁﻅﻉﻊﻋﻌﻍﻎﻏﻐﻑﻓﻕﻗﻙﻛﻝﻟﻡﻣﻥﻧﻩﻫﻬﻭﻯﻰﻱﻲﻳﻵﻶﻷﻸﻻﻼ'


CHARS_CP864 = charblocks([(0x0, 0x24), (0x26, 0x7f), (0xa0, 0xa0), (0xa2, 0xa4), (0xa6, 0xa6), (0xab, 0xad), (0xb0, 0xb1), (0xb7, 0xb7), (0xbb, 0xbd), (0xd7, 0xd7), (0xf7, 0xf7), (0x3b2, 0x3b2), (0x3c6, 0x3c6), (0x60c, 0x60c), (0x61b, 0x61b), (0x61f, 0x61f), (0x640, 0x640), (0x651, 0x651), (0x660, 0x66a), (0x2219, 0x221a), (0x221e, 0x221e), (0x2248, 0x2248), (0x2500, 0x2500), (0x2502, 0x2502), (0x250c, 0x250c), (0x2510, 0x2510), (0x2514, 0x2514), (0x2518, 0x2518), (0x251c, 0x251c), (0x2524, 0x2524), (0x252c, 0x252c), (0x2534, 0x2534), (0x253c, 0x253c), (0x2592, 0x2592), (0x25a0, 0x25a0), (0xfe7d, 0xfe7d), (0xfe80, 0xfe85), (0xfe8b, 0xfe8b), (0xfe8d, 0xfe8f), (0xfe91, 0xfe91), (0xfe93, 0xfe93), (0xfe95, 0xfe95), (0xfe97, 0xfe97), (0xfe99, 0xfe99), (0xfe9b, 0xfe9b), (0xfe9d, 0xfe9d), (0xfe9f, 0xfe9f), (0xfea1, 0xfea1), (0xfea3, 0xfea3), (0xfea5, 0xfea5), (0xfea7, 0xfea7), (0xfea9, 0xfea9), (0xfeab, 0xfeab), (0xfead, 0xfead), (0xfeaf, 0xfeaf), (0xfeb1, 0xfeb1), (0xfeb3, 0xfeb3), (0xfeb5, 0xfeb5), (0xfeb7, 0xfeb7), (0xfeb9, 0xfeb9), (0xfebb, 0xfebb), (0xfebd, 0xfebd), (0xfebf, 0xfebf), (0xfec1, 0xfec1), (0xfec5, 0xfec5), (0xfec9, 0xfed1), (0xfed3, 0xfed3), (0xfed5, 0xfed5), (0xfed7, 0xfed7), (0xfed9, 0xfed9), (0xfedb, 0xfedb), (0xfedd, 0xfedd), (0xfedf, 0xfedf), (0xfee1, 0xfee1), (0xfee3, 0xfee3), (0xfee5, 0xfee5), (0xfee7, 0xfee7), (0xfee9, 0xfee9), (0xfeeb, 0xfeed), (0xfeef, 0xfef3), (0xfef5, 0xfef8), (0xfefb, 0xfefc)])



add_encoding('cp864', characters=CHARS_CP864,
             scripts={'Zinh': 1, 'Arab': 83, 'Grek': 2, 'Latn': 52, 'Zyyy': 112},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_CP865 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0¡£¤ª«¬°±²µ·º¼½¿ÄÅÆÇÉÑÖØÜßàáâäåæçèéêëìíîïñòóôö÷øùúûüÿƒΓΘΣΦΩαδεπστφⁿ₧∙√∞∩≈≡≤≥⌐⌠⌡─│┌┐└┘├┤┬┴┼═║╒╓╔╕╖╗╘╙╚╛╜╝╞╟╠╡╢╣╤╥╦╧╨╩╪╫╬▀▄█▌▐░▒▓■'


CHARS_CP865 = charblocks([(0x0, 0x7f), (0xa0, 0xa1), (0xa3, 0xa4), (0xaa, 0xac), (0xb0, 0xb2), (0xb5, 0xb5), (0xb7, 0xb7), (0xba, 0xba), (0xbc, 0xbd), (0xbf, 0xbf), (0xc4, 0xc7), (0xc9, 0xc9), (0xd1, 0xd1), (0xd6, 0xd6), (0xd8, 0xd8), (0xdc, 0xdc), (0xdf, 0xe2), (0xe4, 0xef), (0xf1, 0xf4), (0xf6, 0xfc), (0xff, 0xff), (0x192, 0x192), (0x393, 0x393), (0x398, 0x398), (0x3a3, 0x3a3), (0x3a6, 0x3a6), (0x3a9, 0x3a9), (0x3b1, 0x3b1), (0x3b4, 0x3b5), (0x3c0, 0x3c0), (0x3c3, 0x3c4), (0x3c6, 0x3c6), (0x207f, 0x207f), (0x20a7, 0x20a7), (0x2219, 0x221a), (0x221e, 0x221e), (0x2229, 0x2229), (0x2248, 0x2248), (0x2261, 0x2261), (0x2264, 0x2265), (0x2310, 0x2310), (0x2320, 0x2321), (0x2500, 0x2500), (0x2502, 0x2502), (0x250c, 0x250c), (0x2510, 0x2510), (0x2514, 0x2514), (0x2518, 0x2518), (0x251c, 0x251c), (0x2524, 0x2524), (0x252c, 0x252c), (0x2534, 0x2534), (0x253c, 0x253c), (0x2550, 0x256c), (0x2580, 0x2580), (0x2584, 0x2584), (0x2588, 0x2588), (0x258c, 0x258c), (0x2590, 0x2593), (0x25a0, 0x25a0)])



add_encoding('cp865', characters=CHARS_CP865,
             scripts={'Latn': 92, 'Grek': 12, 'Zyyy': 152},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_CP866 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0¤°·ЁЄЇЎАБВГДЕЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯабвгдежзийклмнопрстуфхцчшщъыьэюяёєїў№∙√─│┌┐└┘├┤┬┴┼═║╒╓╔╕╖╗╘╙╚╛╜╝╞╟╠╡╢╣╤╥╦╧╨╩╪╫╬▀▄█▌▐░▒▓■'


CHARS_CP866 = charblocks([(0x0, 0x7f), (0xa0, 0xa0), (0xa4, 0xa4), (0xb0, 0xb0), (0xb7, 0xb7), (0x401, 0x401), (0x404, 0x404), (0x407, 0x407), (0x40e, 0x40e), (0x410, 0x44f), (0x451, 0x451), (0x454, 0x454), (0x457, 0x457), (0x45e, 0x45e), (0x2116, 0x2116), (0x2219, 0x221a), (0x2500, 0x2500), (0x2502, 0x2502), (0x250c, 0x250c), (0x2510, 0x2510), (0x2514, 0x2514), (0x2518, 0x2518), (0x251c, 0x251c), (0x2524, 0x2524), (0x252c, 0x252c), (0x2534, 0x2534), (0x253c, 0x253c), (0x2550, 0x256c), (0x2580, 0x2580), (0x2584, 0x2584), (0x2588, 0x2588), (0x258c, 0x258c), (0x2590, 0x2593), (0x25a0, 0x25a0)])



add_encoding('cp866', characters=CHARS_CP866,
             scripts={'Latn': 52, 'Zyyy': 132, 'Cyrl': 72},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_CP869 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0£¦§¨©«¬\xad°±²³·»½΄΅ΆΈΉΊΌΎΏΐΑΒΓΔΕΖΗΘΙΚΛΜΝΞΟΠΡΣΤΥΦΧΨΩΪΫάέήίΰαβγδεζηθικλμνξοπρςστυφχψωϊϋόύώ―‘’─│┌┐└┘├┤┬┴┼═║╔╗╚╝╠╣╦╩╬▀▄█░▒▓■'


CHARS_CP869 = charblocks([(0x0, 0x7f), (0xa0, 0xa0), (0xa3, 0xa3), (0xa6, 0xa9), (0xab, 0xad), (0xb0, 0xb3), (0xb7, 0xb7), (0xbb, 0xbb), (0xbd, 0xbd), (0x384, 0x386), (0x388, 0x38a), (0x38c, 0x38c), (0x38e, 0x3a1), (0x3a3, 0x3ce), (0x2015, 0x2015), (0x2018, 0x2019), (0x2500, 0x2500), (0x2502, 0x2502), (0x250c, 0x250c), (0x2510, 0x2510), (0x2514, 0x2514), (0x2518, 0x2518), (0x251c, 0x251c), (0x2524, 0x2524), (0x252c, 0x252c), (0x2534, 0x2534), (0x253c, 0x253c), (0x2550, 0x2551), (0x2554, 0x2554), (0x2557, 0x2557), (0x255a, 0x255a), (0x255d, 0x255d), (0x2560, 0x2560), (0x2563, 0x2563), (0x2566, 0x2566), (0x2569, 0x2569), (0x256c, 0x256c), (0x2580, 0x2580), (0x2584, 0x2584), (0x2588, 0x2588), (0x2591, 0x2593), (0x25a0, 0x25a0)])



add_encoding('cp869', characters=CHARS_CP869,
             scripts={'Latn': 52, 'Grek': 70, 'Zyyy': 125},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_CP874 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0กขฃคฅฆงจฉชซฌญฎฏฐฑฒณดตถทธนบปผฝพฟภมยรฤลฦวศษสหฬอฮฯะัาำิีึืฺุู฿เแโใไๅๆ็่้๊๋์ํ๎๏๐๑๒๓๔๕๖๗๘๙๚๛–—‘’“”•…€'


CHARS_CP874 = charblocks([(0x0, 0x7f), (0xa0, 0xa0), (0xe01, 0xe3a), (0xe3f, 0xe5b), (0x2013, 0x2014), (0x2018, 0x2019), (0x201c, 0x201d), (0x2022, 0x2022), (0x2026, 0x2026), (0x20ac, 0x20ac)])



add_encoding('cp874', characters=CHARS_CP874,
             scripts={'Latn': 52, 'Thai': 86, 'Zyyy': 87},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_CP875 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f\xa0£¦§¨©«¬\xad°±²³´»½΅Ά·ΈΉΊΌΎΏΐΑΒΓΔΕΖΗΘΙΚΛΜΝΞΟΠΡΣΤΥΦΧΨΩΪΫάέήίΰαβγδεζηθικλμνξοπρςστυφχψωϊϋόύώ―‘’'


CHARS_CP875 = charblocks([(0x0, 0xa0), (0xa3, 0xa3), (0xa6, 0xa9), (0xab, 0xad), (0xb0, 0xb4), (0xbb, 0xbb), (0xbd, 0xbd), (0x385, 0x38a), (0x38c, 0x38c), (0x38e, 0x3a1), (0x3a3, 0x3ce), (0x2015, 0x2015), (0x2018, 0x2019)])



add_encoding('cp875', characters=CHARS_CP875,
             scripts={'Latn': 52, 'Grek': 69, 'Zyyy': 129},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)


add_encoding('cp949', characters=None,
             scripts={'Grek': 49, 'Kana': 86, 'Zyyy': 526, 'Latn': 155, 'Hani': 4888, 'Hang': 11323, 'Cyrl': 66, 'Hira': 83},
             multibyte=True, fixed=False, unicode=False,
             charsize=None, maxbits=16)


add_encoding('euc_jis_2004', characters=None,
             scripts={'Latn': 392, 'Grek': 74, 'Kana': 205, 'Zyyy': 561, 'Zinh': 32, 'Hani': 13112, 'Cyrl': 92, 'Hira': 89},
             multibyte=True, fixed=False, unicode=False,
             charsize=None, maxbits=24)


add_encoding('euc_jisx0213', characters=None,
             scripts={'Latn': 392, 'Grek': 74, 'Kana': 205, 'Zyyy': 561, 'Zinh': 32, 'Hani': 13102, 'Cyrl': 92, 'Hira': 89},
             multibyte=True, fixed=False, unicode=False,
             charsize=None, maxbits=24)


add_encoding('euc_kr', characters=None,
             scripts={'Grek': 49, 'Kana': 86, 'Zyyy': 526, 'Latn': 155, 'Hani': 4888, 'Hang': 11323, 'Cyrl': 66, 'Hira': 83},
             multibyte=True, fixed=False, unicode=False,
             charsize=None, maxbits=64)


add_encoding('gb18030', characters=UNICODE,
             scripts=UNICODE_SCRIPTS,
             multibyte=True, fixed=False, unicode=True,
             charsize=None, maxbits=32)


add_encoding('gb2312', characters=None,
             scripts={'Grek': 48, 'Kana': 86, 'Zyyy': 347, 'Latn': 142, 'Hani': 6764, 'Bopo': 37, 'Cyrl': 66, 'Hira': 83},
             multibyte=True, fixed=False, unicode=False,
             charsize=None, maxbits=16)


add_encoding('gbk', characters=None,
             scripts={'Grek': 48, 'Kana': 88, 'Zyyy': 505, 'Latn': 156, 'Hani': 20934, 'Bopo': 37, 'Cyrl': 66, 'Hira': 85},
             multibyte=True, fixed=False, unicode=False,
             charsize=None, maxbits=16)

# CHARS_HP_ROMAN8 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f\xa0¡¢£¤¥§¨ª«¯°±´µ¶·º»¼½¾¿ÀÁÂÃÄÅÆÇÈÉÊËÌÍÎÏÐÑÒÓÔÕÖØÙÚÛÜÝÞßàáâãäåæçèéêëìíîïðñòóôõöøùúûüýþÿŠšŸƒˆˋ˜—₤■'


CHARS_HP_ROMAN8 = charblocks([(0x0, 0xa5), (0xa7, 0xa8), (0xaa, 0xab), (0xaf, 0xb1), (0xb4, 0xb7), (0xba, 0xd6), (0xd8, 0xf6), (0xf8, 0xff), (0x160, 0x161), (0x178, 0x178), (0x192, 0x192), (0x2c6, 0x2c6), (0x2cb, 0x2cb), (0x2dc, 0x2dc), (0x2014, 0x2014), (0x20a4, 0x20a4), (0x25a0, 0x25a0)])



add_encoding('hp_roman8', characters=CHARS_HP_ROMAN8,
             scripts={'Latn': 120, 'Zyyy': 135},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)


add_encoding('hz', characters=None,
             scripts={'Grek': 48, 'Kana': 86, 'Zyyy': 347, 'Latn': 142, 'Hani': 6764, 'Bopo': 37, 'Cyrl': 66, 'Hira': 83},
             multibyte=True, fixed=False, unicode=False,
             charsize=None, maxbits=48)


add_encoding('iso2022_jp', characters=None,
             scripts={'Grek': 48, 'Kana': 88, 'Zyyy': 259, 'Latn': 105, 'Hani': 6358, 'Cyrl': 66, 'Hira': 85},
             multibyte=True, fixed=False, unicode=False,
             charsize=None, maxbits=64)


add_encoding('iso2022_jp_1', characters=None,
             scripts={'Grek': 70, 'Kana': 88, 'Zyyy': 276, 'Latn': 305, 'Hani': 12159, 'Cyrl': 92, 'Hira': 85},
             multibyte=True, fixed=False, unicode=False,
             charsize=None, maxbits=72)


add_encoding('iso2022_jp_2', characters=None,
             scripts={'Hira': 85, 'Grek': 71, 'Kana': 88, 'Zyyy': 601, 'Latn': 329, 'Hani': 14924, 'Bopo': 37, 'Cyrl': 92, 'Hang': 2501},
             multibyte=True, fixed=False, unicode=False,
             charsize=None, maxbits=72)


add_encoding('iso2022_jp_2004', characters=None,
             scripts={'Latn': 342, 'Grek': 53, 'Kana': 150, 'Zyyy': 549, 'Zinh': 32, 'Hani': 10054, 'Cyrl': 66, 'Hira': 89},
             multibyte=True, fixed=False, unicode=False,
             charsize=None, maxbits=72)


add_encoding('iso2022_jp_3', characters=None,
             scripts={'Latn': 342, 'Grek': 53, 'Kana': 150, 'Zyyy': 549, 'Zinh': 32, 'Hani': 10044, 'Cyrl': 66, 'Hira': 89},
             multibyte=True, fixed=False, unicode=False,
             charsize=None, maxbits=72)


add_encoding('iso2022_jp_ext', characters=None,
             scripts={'Grek': 70, 'Kana': 143, 'Zyyy': 284, 'Latn': 305, 'Hani': 12159, 'Cyrl': 92, 'Hira': 85},
             multibyte=True, fixed=False, unicode=False,
             charsize=None, maxbits=72)


add_encoding('iso2022_kr', characters=None,
             scripts={'Grek': 49, 'Kana': 86, 'Zyyy': 526, 'Latn': 155, 'Hani': 4888, 'Hang': 2501, 'Cyrl': 66, 'Hira': 83},
             multibyte=True, fixed=False, unicode=False,
             charsize=None, maxbits=64)

# CHARS_ISO8859_10 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f\xa0§\xad°·ÁÂÃÄÅÆÉËÍÎÏÐÓÔÕÖØÚÛÜÝÞßáâãäåæéëíîïðóôõöøúûüýþĀāĄąČčĐđĒēĖėĘęĢģĨĩĪīĮįĶķĸĻļŅņŊŋŌōŠšŦŧŨũŪūŲųŽž―'


CHARS_ISO8859_10 = charblocks([(0x0, 0xa0), (0xa7, 0xa7), (0xad, 0xad), (0xb0, 0xb0), (0xb7, 0xb7), (0xc1, 0xc6), (0xc9, 0xc9), (0xcb, 0xcb), (0xcd, 0xd0), (0xd3, 0xd6), (0xd8, 0xd8), (0xda, 0xdf), (0xe1, 0xe6), (0xe9, 0xe9), (0xeb, 0xeb), (0xed, 0xf0), (0xf3, 0xf6), (0xf8, 0xf8), (0xfa, 0xfe), (0x100, 0x101), (0x104, 0x105), (0x10c, 0x10d), (0x110, 0x113), (0x116, 0x119), (0x122, 0x123), (0x128, 0x12b), (0x12e, 0x12f), (0x136, 0x138), (0x13b, 0x13c), (0x145, 0x146), (0x14a, 0x14d), (0x160, 0x161), (0x166, 0x16b), (0x172, 0x173), (0x17d, 0x17e), (0x2015, 0x2015)])



add_encoding('iso8859_10', characters=CHARS_ISO8859_10,
             scripts={'Latn': 142, 'Zyyy': 114},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_ISO8859_11 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f\xa0กขฃคฅฆงจฉชซฌญฎฏฐฑฒณดตถทธนบปผฝพฟภมยรฤลฦวศษสหฬอฮฯะัาำิีึืฺุู฿เแโใไๅๆ็่้๊๋์ํ๎๏๐๑๒๓๔๕๖๗๘๙๚๛'


CHARS_ISO8859_11 = charblocks([(0x0, 0xa0), (0xe01, 0xe3a), (0xe3f, 0xe5b)])



add_encoding('iso8859_11', characters=CHARS_ISO8859_11,
             scripts={'Latn': 52, 'Thai': 86, 'Zyyy': 110},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_ISO8859_13 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f\xa0¢£¤¦§©«¬\xad®°±²³µ¶·¹»¼½¾ÄÅÆÉÓÕÖ×ØÜßäåæéóõö÷øüĀāĄąĆćČčĒēĖėĘęĢģĪīĮįĶķĻļŁłŃńŅņŌōŖŗŚśŠšŪūŲųŹźŻżŽž’“”„'


CHARS_ISO8859_13 = charblocks([(0x0, 0xa0), (0xa2, 0xa4), (0xa6, 0xa7), (0xa9, 0xa9), (0xab, 0xae), (0xb0, 0xb3), (0xb5, 0xb7), (0xb9, 0xb9), (0xbb, 0xbe), (0xc4, 0xc6), (0xc9, 0xc9), (0xd3, 0xd3), (0xd5, 0xd8), (0xdc, 0xdc), (0xdf, 0xdf), (0xe4, 0xe6), (0xe9, 0xe9), (0xf3, 0xf3), (0xf5, 0xf8), (0xfc, 0xfc), (0x100, 0x101), (0x104, 0x107), (0x10c, 0x10d), (0x112, 0x113), (0x116, 0x119), (0x122, 0x123), (0x12a, 0x12b), (0x12e, 0x12f), (0x136, 0x137), (0x13b, 0x13c), (0x141, 0x146), (0x14c, 0x14d), (0x156, 0x157), (0x15a, 0x15b), (0x160, 0x161), (0x16a, 0x16b), (0x172, 0x173), (0x179, 0x17e), (0x2019, 0x2019), (0x201c, 0x201e)])



add_encoding('iso8859_13', characters=CHARS_ISO8859_13,
             scripts={'Latn': 119, 'Zyyy': 137},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_ISO8859_14 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f\xa0£§©\xad®¶ÀÁÂÃÄÅÆÇÈÉÊËÌÍÎÏÑÒÓÔÕÖØÙÚÛÜÝßàáâãäåæçèéêëìíîïñòóôõöøùúûüýÿĊċĠġŴŵŶŷŸḂḃḊḋḞḟṀṁṖṗṠṡṪṫẀẁẂẃẄẅỲỳ'


CHARS_ISO8859_14 = charblocks([(0x0, 0xa0), (0xa3, 0xa3), (0xa7, 0xa7), (0xa9, 0xa9), (0xad, 0xae), (0xb6, 0xb6), (0xc0, 0xcf), (0xd1, 0xd6), (0xd8, 0xdd), (0xdf, 0xef), (0xf1, 0xf6), (0xf8, 0xfd), (0xff, 0xff), (0x10a, 0x10b), (0x120, 0x121), (0x174, 0x178), (0x1e02, 0x1e03), (0x1e0a, 0x1e0b), (0x1e1e, 0x1e1f), (0x1e40, 0x1e41), (0x1e56, 0x1e57), (0x1e60, 0x1e61), (0x1e6a, 0x1e6b), (0x1e80, 0x1e85), (0x1ef2, 0x1ef3)])



add_encoding('iso8859_14', characters=CHARS_ISO8859_14,
             scripts={'Latn': 141, 'Zyyy': 115},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_ISO8859_15 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f\xa0¡¢£¥§©ª«¬\xad®¯°±²³µ¶·¹º»¿ÀÁÂÃÄÅÆÇÈÉÊËÌÍÎÏÐÑÒÓÔÕÖ×ØÙÚÛÜÝÞßàáâãäåæçèéêëìíîïðñòóôõö÷øùúûüýþÿŒœŠšŸŽž€'


CHARS_ISO8859_15 = charblocks([(0x0, 0xa3), (0xa5, 0xa5), (0xa7, 0xa7), (0xa9, 0xb3), (0xb5, 0xb7), (0xb9, 0xbb), (0xbf, 0xff), (0x152, 0x153), (0x160, 0x161), (0x178, 0x178), (0x17d, 0x17e), (0x20ac, 0x20ac)])



add_encoding('iso8859_15', characters=CHARS_ISO8859_15,
             scripts={'Latn': 123, 'Zyyy': 133},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_ISO8859_16 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f\xa0§©«\xad°±¶·»ÀÁÂÄÆÇÈÉÊËÌÍÎÏÒÓÔÖÙÚÛÜßàáâäæçèéêëìíîïòóôöùúûüÿĂăĄąĆćČčĐđĘęŁłŃńŐőŒœŚśŠšŰűŸŹźŻżŽžȘșȚț”„€'


CHARS_ISO8859_16 = charblocks([(0x0, 0xa0), (0xa7, 0xa7), (0xa9, 0xa9), (0xab, 0xab), (0xad, 0xad), (0xb0, 0xb1), (0xb6, 0xb7), (0xbb, 0xbb), (0xc0, 0xc2), (0xc4, 0xc4), (0xc6, 0xcf), (0xd2, 0xd4), (0xd6, 0xd6), (0xd9, 0xdc), (0xdf, 0xe2), (0xe4, 0xe4), (0xe6, 0xef), (0xf2, 0xf4), (0xf6, 0xf6), (0xf9, 0xfc), (0xff, 0xff), (0x102, 0x107), (0x10c, 0x10d), (0x110, 0x111), (0x118, 0x119), (0x141, 0x144), (0x150, 0x153), (0x15a, 0x15b), (0x160, 0x161), (0x170, 0x171), (0x178, 0x17e), (0x218, 0x21b), (0x201d, 0x201e), (0x20ac, 0x20ac)])



add_encoding('iso8859_16', characters=CHARS_ISO8859_16,
             scripts={'Latn': 135, 'Zyyy': 121},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_ISO8859_2 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f\xa0¤§¨\xad°´¸ÁÂÄÇÉËÍÎÓÔÖ×ÚÜÝßáâäçéëíîóôö÷úüýĂăĄąĆćČčĎďĐđĘęĚěĹĺĽľŁłŃńŇňŐőŔŕŘřŚśŞşŠšŢţŤťŮůŰűŹźŻżŽžˇ˘˙˛˝'


CHARS_ISO8859_2 = charblocks([(0x0, 0xa0), (0xa4, 0xa4), (0xa7, 0xa8), (0xad, 0xad), (0xb0, 0xb0), (0xb4, 0xb4), (0xb8, 0xb8), (0xc1, 0xc2), (0xc4, 0xc4), (0xc7, 0xc7), (0xc9, 0xc9), (0xcb, 0xcb), (0xcd, 0xce), (0xd3, 0xd4), (0xd6, 0xd7), (0xda, 0xda), (0xdc, 0xdd), (0xdf, 0xdf), (0xe1, 0xe2), (0xe4, 0xe4), (0xe7, 0xe7), (0xe9, 0xe9), (0xeb, 0xeb), (0xed, 0xee), (0xf3, 0xf4), (0xf6, 0xf7), (0xfa, 0xfa), (0xfc, 0xfd), (0x102, 0x107), (0x10c, 0x111), (0x118, 0x11b), (0x139, 0x13a), (0x13d, 0x13e), (0x141, 0x144), (0x147, 0x148), (0x150, 0x151), (0x154, 0x155), (0x158, 0x15b), (0x15e, 0x165), (0x16e, 0x171), (0x179, 0x17e), (0x2c7, 0x2c7), (0x2d8, 0x2d9), (0x2db, 0x2db), (0x2dd, 0x2dd)])



add_encoding('iso8859_2', characters=CHARS_ISO8859_2,
             scripts={'Latn': 133, 'Zyyy': 123},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_ISO8859_3 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f\xa0£¤§¨\xad°²³´µ·¸½ÀÁÂÄÇÈÉÊËÌÍÎÏÑÒÓÔÖ×ÙÚÛÜßàáâäçèéêëìíîïñòóôö÷ùúûüĈĉĊċĜĝĞğĠġĤĥĦħİıĴĵŜŝŞşŬŭŻż˘˙'


CHARS_ISO8859_3 = charblocks([(0x0, 0xa0), (0xa3, 0xa4), (0xa7, 0xa8), (0xad, 0xad), (0xb0, 0xb0), (0xb2, 0xb5), (0xb7, 0xb8), (0xbd, 0xbd), (0xc0, 0xc2), (0xc4, 0xc4), (0xc7, 0xcf), (0xd1, 0xd4), (0xd6, 0xd7), (0xd9, 0xdc), (0xdf, 0xe2), (0xe4, 0xe4), (0xe7, 0xef), (0xf1, 0xf4), (0xf6, 0xf7), (0xf9, 0xfc), (0x108, 0x10b), (0x11c, 0x121), (0x124, 0x127), (0x130, 0x131), (0x134, 0x135), (0x15c, 0x15f), (0x16c, 0x16d), (0x17b, 0x17c), (0x2d8, 0x2d9)])



add_encoding('iso8859_3', characters=CHARS_ISO8859_3,
             scripts={'Latn': 123, 'Zyyy': 126},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_ISO8859_4 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f\xa0¤§¨\xad¯°´¸ÁÂÃÄÅÆÉËÍÎÔÕÖ×ØÚÛÜßáâãäåæéëíîôõö÷øúûüĀāĄąČčĐđĒēĖėĘęĢģĨĩĪīĮįĶķĸĻļŅņŊŋŌōŖŗŠšŦŧŨũŪūŲųŽžˇ˙˛'


CHARS_ISO8859_4 = charblocks([(0x0, 0xa0), (0xa4, 0xa4), (0xa7, 0xa8), (0xad, 0xad), (0xaf, 0xb0), (0xb4, 0xb4), (0xb8, 0xb8), (0xc1, 0xc6), (0xc9, 0xc9), (0xcb, 0xcb), (0xcd, 0xce), (0xd4, 0xd8), (0xda, 0xdc), (0xdf, 0xdf), (0xe1, 0xe6), (0xe9, 0xe9), (0xeb, 0xeb), (0xed, 0xee), (0xf4, 0xf8), (0xfa, 0xfc), (0x100, 0x101), (0x104, 0x105), (0x10c, 0x10d), (0x110, 0x113), (0x116, 0x119), (0x122, 0x123), (0x128, 0x12b), (0x12e, 0x12f), (0x136, 0x138), (0x13b, 0x13c), (0x145, 0x146), (0x14a, 0x14d), (0x156, 0x157), (0x160, 0x161), (0x166, 0x16b), (0x172, 0x173), (0x17d, 0x17e), (0x2c7, 0x2c7), (0x2d9, 0x2d9), (0x2db, 0x2db)])



add_encoding('iso8859_4', characters=CHARS_ISO8859_4,
             scripts={'Latn': 134, 'Zyyy': 122},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_ISO8859_5 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f\xa0§\xadЁЂЃЄЅІЇЈЉЊЋЌЎЏАБВГДЕЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯабвгдежзийклмнопрстуфхцчшщъыьэюяёђѓєѕіїјљњћќўџ№'


CHARS_ISO8859_5 = charblocks([(0x0, 0xa0), (0xa7, 0xa7), (0xad, 0xad), (0x401, 0x40c), (0x40e, 0x44f), (0x451, 0x45c), (0x45e, 0x45f), (0x2116, 0x2116)])



add_encoding('iso8859_5', characters=CHARS_ISO8859_5,
             scripts={'Latn': 52, 'Zyyy': 112, 'Cyrl': 92},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_ISO8859_6 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f\xa0¤\xad،؛؟ءآأؤإئابةتثجحخدذرزسشصضطظعغـفقكلمنهوىيًٌٍَُِّْ'


CHARS_ISO8859_6 = charblocks([(0x0, 0xa0), (0xa4, 0xa4), (0xad, 0xad), (0x60c, 0x60c), (0x61b, 0x61b), (0x61f, 0x61f), (0x621, 0x63a), (0x640, 0x652)])



add_encoding('iso8859_6', characters=CHARS_ISO8859_6,
             scripts={'Zinh': 8, 'Arab': 36, 'Latn': 52, 'Zyyy': 115},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_ISO8859_7 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f\xa0£¦§¨©«¬\xad°±²³·»½ͺ΄΅ΆΈΉΊΌΎΏΐΑΒΓΔΕΖΗΘΙΚΛΜΝΞΟΠΡΣΤΥΦΧΨΩΪΫάέήίΰαβγδεζηθικλμνξοπρςστυφχψωϊϋόύώ―‘’€₯'


CHARS_ISO8859_7 = charblocks([(0x0, 0xa0), (0xa3, 0xa3), (0xa6, 0xa9), (0xab, 0xad), (0xb0, 0xb3), (0xb7, 0xb7), (0xbb, 0xbb), (0xbd, 0xbd), (0x37a, 0x37a), (0x384, 0x386), (0x388, 0x38a), (0x38c, 0x38c), (0x38e, 0x3a1), (0x3a3, 0x3ce), (0x2015, 0x2015), (0x2018, 0x2019), (0x20ac, 0x20ac), (0x20af, 0x20af)])



add_encoding('iso8859_7', characters=CHARS_ISO8859_7,
             scripts={'Latn': 52, 'Grek': 71, 'Zyyy': 130},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_ISO8859_8 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f\xa0¢£¤¥¦§¨©«¬\xad®¯°±²³´µ¶·¸¹»¼½¾×÷אבגדהוזחטיךכלםמןנסעףפץצקרשת\u200e\u200f‗'


CHARS_ISO8859_8 = charblocks([(0x0, 0xa0), (0xa2, 0xa9), (0xab, 0xb9), (0xbb, 0xbe), (0xd7, 0xd7), (0xf7, 0xf7), (0x5d0, 0x5ea), (0x200e, 0x200f), (0x2017, 0x2017)])



add_encoding('iso8859_8', characters=CHARS_ISO8859_8,
             scripts={'Latn': 52, 'Hebr': 27, 'Zyyy': 141},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)


add_encoding('iso8859_9', characters=CHARS_CP1026,
             scripts={'Latn': 116, 'Zyyy': 140},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)


add_encoding('johab', characters=None,
             scripts={'Grek': 49, 'Kana': 86, 'Zyyy': 526, 'Latn': 155, 'Hani': 4888, 'Hang': 11323, 'Cyrl': 66, 'Hira': 83},
             multibyte=True, fixed=False, unicode=False,
             charsize=None, maxbits=16)

# CHARS_KOI8_R = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0©°²·÷ЁАБВГДЕЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯабвгдежзийклмнопрстуфхцчшщъыьэюяё∙√≈≤≥⌠⌡─│┌┐└┘├┤┬┴┼═║╒╓╔╕╖╗╘╙╚╛╜╝╞╟╠╡╢╣╤╥╦╧╨╩╪╫╬▀▄█▌▐░▒▓■'


CHARS_KOI8_R = charblocks([(0x0, 0x7f), (0xa0, 0xa0), (0xa9, 0xa9), (0xb0, 0xb0), (0xb2, 0xb2), (0xb7, 0xb7), (0xf7, 0xf7), (0x401, 0x401), (0x410, 0x44f), (0x451, 0x451), (0x2219, 0x221a), (0x2248, 0x2248), (0x2264, 0x2265), (0x2320, 0x2321), (0x2500, 0x2500), (0x2502, 0x2502), (0x250c, 0x250c), (0x2510, 0x2510), (0x2514, 0x2514), (0x2518, 0x2518), (0x251c, 0x251c), (0x2524, 0x2524), (0x252c, 0x252c), (0x2534, 0x2534), (0x253c, 0x253c), (0x2550, 0x256c), (0x2580, 0x2580), (0x2584, 0x2584), (0x2588, 0x2588), (0x258c, 0x258c), (0x2590, 0x2593), (0x25a0, 0x25a0)])



add_encoding('koi8_r', characters=CHARS_KOI8_R,
             scripts={'Latn': 52, 'Zyyy': 138, 'Cyrl': 66},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_KOI8_U = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0©°²·÷ЁЄІЇАБВГДЕЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯабвгдежзийклмнопрстуфхцчшщъыьэюяёєіїҐґ∙√≈≤≥⌠⌡─│┌┐└┘├┤┬┴┼═║╒╔╗╘╙╚╛╝╞╟╠╡╣╦╧╨╩╪╬▀▄█▌▐░▒▓■'


CHARS_KOI8_U = charblocks([(0x0, 0x7f), (0xa0, 0xa0), (0xa9, 0xa9), (0xb0, 0xb0), (0xb2, 0xb2), (0xb7, 0xb7), (0xf7, 0xf7), (0x401, 0x401), (0x404, 0x404), (0x406, 0x407), (0x410, 0x44f), (0x451, 0x451), (0x454, 0x454), (0x456, 0x457), (0x490, 0x491), (0x2219, 0x221a), (0x2248, 0x2248), (0x2264, 0x2265), (0x2320, 0x2321), (0x2500, 0x2500), (0x2502, 0x2502), (0x250c, 0x250c), (0x2510, 0x2510), (0x2514, 0x2514), (0x2518, 0x2518), (0x251c, 0x251c), (0x2524, 0x2524), (0x252c, 0x252c), (0x2534, 0x2534), (0x253c, 0x253c), (0x2550, 0x2552), (0x2554, 0x2554), (0x2557, 0x255b), (0x255d, 0x2561), (0x2563, 0x2563), (0x2566, 0x256a), (0x256c, 0x256c), (0x2580, 0x2580), (0x2584, 0x2584), (0x2588, 0x2588), (0x258c, 0x258c), (0x2590, 0x2593), (0x25a0, 0x25a0)])



add_encoding('koi8_u', characters=CHARS_KOI8_U,
             scripts={'Latn': 52, 'Zyyy': 130, 'Cyrl': 74},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)


add_encoding('latin_1', characters=CHARS_CP037,
             scripts={'Latn': 116, 'Zyyy': 140},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_MAC_ARABIC = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0«»ÄÇÉÑÖÜàáâäçèéêëíîïñóôö÷ùúûü،؛؟ءآأؤإئابةتثجحخدذرزسشصضطظعغـفقكلمنهوىيًٌٍَُِّْ٠١٢٣٤٥٦٧٨٩٪ٹپچڈڑژڤگںےە…❊'


CHARS_MAC_ARABIC = charblocks([(0x0, 0x7f), (0xa0, 0xa0), (0xab, 0xab), (0xbb, 0xbb), (0xc4, 0xc4), (0xc7, 0xc7), (0xc9, 0xc9), (0xd1, 0xd1), (0xd6, 0xd6), (0xdc, 0xdc), (0xe0, 0xe2), (0xe4, 0xe4), (0xe7, 0xeb), (0xed, 0xef), (0xf1, 0xf1), (0xf3, 0xf4), (0xf6, 0xf7), (0xf9, 0xfc), (0x60c, 0x60c), (0x61b, 0x61b), (0x61f, 0x61f), (0x621, 0x63a), (0x640, 0x652), (0x660, 0x66a), (0x679, 0x679), (0x67e, 0x67e), (0x686, 0x686), (0x688, 0x688), (0x691, 0x691), (0x698, 0x698), (0x6a4, 0x6a4), (0x6af, 0x6af), (0x6ba, 0x6ba), (0x6d2, 0x6d2), (0x6d5, 0x6d5), (0x2026, 0x2026), (0x274a, 0x274a)])



add_encoding('mac_arabic', characters=CHARS_MAC_ARABIC,
             scripts={'Zinh': 8, 'Arab': 58, 'Latn': 78, 'Zyyy': 86},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_MAC_CENTEURO = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0£§¨©«¬®°¶»ÁÄÉÍÓÔÕÖÚÜÝßáäéíóôõö÷úüýĀāĄąĆćČčĎďĒēĖėĘęĚěĢģĪīĮįĶķĹĺĻļĽľŁłŃńŅņŇňŌōŐőŔŕŖŗŘřŚśŠšŤťŪūŮůŰűŲųŹźŻżŽžˇ–—‘’‚“”„†•…‹›™∂∆∑√≠≤≥◊'


CHARS_MAC_CENTEURO = charblocks([(0x0, 0x7f), (0xa0, 0xa0), (0xa3, 0xa3), (0xa7, 0xa9), (0xab, 0xac), (0xae, 0xae), (0xb0, 0xb0), (0xb6, 0xb6), (0xbb, 0xbb), (0xc1, 0xc1), (0xc4, 0xc4), (0xc9, 0xc9), (0xcd, 0xcd), (0xd3, 0xd6), (0xda, 0xda), (0xdc, 0xdd), (0xdf, 0xdf), (0xe1, 0xe1), (0xe4, 0xe4), (0xe9, 0xe9), (0xed, 0xed), (0xf3, 0xf7), (0xfa, 0xfa), (0xfc, 0xfd), (0x100, 0x101), (0x104, 0x107), (0x10c, 0x10f), (0x112, 0x113), (0x116, 0x11b), (0x122, 0x123), (0x12a, 0x12b), (0x12e, 0x12f), (0x136, 0x137), (0x139, 0x13e), (0x141, 0x148), (0x14c, 0x14d), (0x150, 0x151), (0x154, 0x15b), (0x160, 0x161), (0x164, 0x165), (0x16a, 0x16b), (0x16e, 0x173), (0x179, 0x17e), (0x2c7, 0x2c7), (0x2013, 0x2014), (0x2018, 0x201a), (0x201c, 0x201e), (0x2020, 0x2020), (0x2022, 0x2022), (0x2026, 0x2026), (0x2039, 0x203a), (0x2122, 0x2122), (0x2202, 0x2202), (0x2206, 0x2206), (0x2211, 0x2211), (0x221a, 0x221a), (0x2260, 0x2260), (0x2264, 0x2265), (0x25ca, 0x25ca)])



add_encoding('mac_centeuro', characters=CHARS_MAC_CENTEURO,
             scripts={'Latn': 145, 'Zyyy': 111},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_MAC_CROATIAN = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0¡¢£§¨©ª«¬®¯°±´µ¶·¸º»¿ÀÁÂÃÄÅÆÇÈÉÊËÌÍÎÏÑÒÓÔÕÖØÙÚÛÜßàáâãäåæçèéêëìíîïñòóôõö÷øùúûüĆćČčĐđıŒœŠšŽžƒˆˇ˚˜Ωπ–—‘’‚“”„†•…‰‹›⁄€™∂∆∏∑√∞∫≈≠≤≥◊\uf8ff'


CHARS_MAC_CROATIAN = charblocks([(0x0, 0x7f), (0xa0, 0xa3), (0xa7, 0xac), (0xae, 0xb1), (0xb4, 0xb8), (0xba, 0xbb), (0xbf, 0xcf), (0xd1, 0xd6), (0xd8, 0xdc), (0xdf, 0xef), (0xf1, 0xfc), (0x106, 0x107), (0x10c, 0x10d), (0x110, 0x111), (0x131, 0x131), (0x152, 0x153), (0x160, 0x161), (0x17d, 0x17e), (0x192, 0x192), (0x2c6, 0x2c7), (0x2da, 0x2da), (0x2dc, 0x2dc), (0x3a9, 0x3a9), (0x3c0, 0x3c0), (0x2013, 0x2014), (0x2018, 0x201a), (0x201c, 0x201e), (0x2020, 0x2020), (0x2022, 0x2022), (0x2026, 0x2026), (0x2030, 0x2030), (0x2039, 0x203a), (0x2044, 0x2044), (0x20ac, 0x20ac), (0x2122, 0x2122), (0x2202, 0x2202), (0x2206, 0x2206), (0x220f, 0x220f), (0x2211, 0x2211), (0x221a, 0x221a), (0x221e, 0x221e), (0x222b, 0x222b), (0x2248, 0x2248), (0x2260, 0x2260), (0x2264, 0x2265), (0x25ca, 0x25ca), (0xf8ff, 0xf8ff)])



add_encoding('mac_croatian', characters=CHARS_MAC_CROATIAN,
             scripts={'Latn': 123, 'Grek': 2, 'Zzzz': 1, 'Zyyy': 130},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_MAC_CYRILLIC = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0£§©«¬®°±µ¶»÷ƒЁЂЃЄЅІЇЈЉЊЋЌЎЏАБВГДЕЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯабвгдежзийклмнопрстуфхцчшщъыьэюяёђѓєѕіїјљњћќўџҐґ–—‘’“”„†•…€№™∆√∞≈≠≤≥'


CHARS_MAC_CYRILLIC = charblocks([(0x0, 0x7f), (0xa0, 0xa0), (0xa3, 0xa3), (0xa7, 0xa7), (0xa9, 0xa9), (0xab, 0xac), (0xae, 0xae), (0xb0, 0xb1), (0xb5, 0xb6), (0xbb, 0xbb), (0xf7, 0xf7), (0x192, 0x192), (0x401, 0x40c), (0x40e, 0x44f), (0x451, 0x45c), (0x45e, 0x45f), (0x490, 0x491), (0x2013, 0x2014), (0x2018, 0x2019), (0x201c, 0x201e), (0x2020, 0x2020), (0x2022, 0x2022), (0x2026, 0x2026), (0x20ac, 0x20ac), (0x2116, 0x2116), (0x2122, 0x2122), (0x2206, 0x2206), (0x221a, 0x221a), (0x221e, 0x221e), (0x2248, 0x2248), (0x2260, 0x2260), (0x2264, 0x2265)])



add_encoding('mac_cyrillic', characters=CHARS_MAC_CYRILLIC,
             scripts={'Latn': 53, 'Zyyy': 109, 'Cyrl': 94},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_MAC_FARSI = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0«»ÄÇÉÑÖÜàáâäçèéêëíîïñóôö÷ùúûü،؛؟ءآأؤإئابةتثجحخدذرزسشصضطظعغـفقكلمنهوىيًٌٍَُِّْ٪ٹپچڈڑژڤگںےە۰۱۲۳۴۵۶۷۸۹…❊'


CHARS_MAC_FARSI = charblocks([(0x0, 0x7f), (0xa0, 0xa0), (0xab, 0xab), (0xbb, 0xbb), (0xc4, 0xc4), (0xc7, 0xc7), (0xc9, 0xc9), (0xd1, 0xd1), (0xd6, 0xd6), (0xdc, 0xdc), (0xe0, 0xe2), (0xe4, 0xe4), (0xe7, 0xeb), (0xed, 0xef), (0xf1, 0xf1), (0xf3, 0xf4), (0xf6, 0xf7), (0xf9, 0xfc), (0x60c, 0x60c), (0x61b, 0x61b), (0x61f, 0x61f), (0x621, 0x63a), (0x640, 0x652), (0x66a, 0x66a), (0x679, 0x679), (0x67e, 0x67e), (0x686, 0x686), (0x688, 0x688), (0x691, 0x691), (0x698, 0x698), (0x6a4, 0x6a4), (0x6af, 0x6af), (0x6ba, 0x6ba), (0x6d2, 0x6d2), (0x6d5, 0x6d5), (0x6f0, 0x6f9), (0x2026, 0x2026), (0x274a, 0x274a)])



add_encoding('mac_farsi', characters=CHARS_MAC_FARSI,
             scripts={'Zinh': 8, 'Arab': 58, 'Latn': 78, 'Zyyy': 86},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_MAC_GREEK = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0£¥¦§¨©«¬\xad®°±²³·¹»½ÄÉÖÜßàâäçèéêëîïôö÷ùûüœ΄΅ΆΈΉΊΌΎΏΐΑΒΓΔΕΖΗΘΙΚΛΜΝΞΟΠΡΣΤΥΦΧΨΩΪΫάέήίΰαβγδεζηθικλμνξοπρςστυφχψωϊϋόύώ–―‘’“”†•…‰€™≈≠≤≥'


CHARS_MAC_GREEK = charblocks([(0x0, 0x7f), (0xa0, 0xa0), (0xa3, 0xa3), (0xa5, 0xa9), (0xab, 0xae), (0xb0, 0xb3), (0xb7, 0xb7), (0xb9, 0xb9), (0xbb, 0xbb), (0xbd, 0xbd), (0xc4, 0xc4), (0xc9, 0xc9), (0xd6, 0xd6), (0xdc, 0xdc), (0xdf, 0xe0), (0xe2, 0xe2), (0xe4, 0xe4), (0xe7, 0xeb), (0xee, 0xef), (0xf4, 0xf4), (0xf6, 0xf7), (0xf9, 0xf9), (0xfb, 0xfc), (0x153, 0x153), (0x384, 0x386), (0x388, 0x38a), (0x38c, 0x38c), (0x38e, 0x3a1), (0x3a3, 0x3ce), (0x2013, 0x2013), (0x2015, 0x2015), (0x2018, 0x2019), (0x201c, 0x201d), (0x2020, 0x2020), (0x2022, 0x2022), (0x2026, 0x2026), (0x2030, 0x2030), (0x20ac, 0x20ac), (0x2122, 0x2122), (0x2248, 0x2248), (0x2260, 0x2260), (0x2264, 0x2265)])



add_encoding('mac_greek', characters=CHARS_MAC_GREEK,
             scripts={'Latn': 73, 'Grek': 70, 'Zyyy': 113},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_MAC_ICELAND = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0¡¢£¥§¨©ª«¬®¯°±´µ¶·¸º»¿ÀÁÂÃÄÅÆÇÈÉÊËÌÍÎÏÐÑÒÓÔÕÖØÙÚÛÜÝÞßàáâãäåæçèéêëìíîïðñòóôõö÷øùúûüýþÿıŒœŸƒˆˇ˘˙˚˛˜˝Ωπ–—‘’‚“”„•…‰⁄€™∂∆∏∑√∞∫≈≠≤≥◊\uf8ff'


CHARS_MAC_ICELAND = charblocks([(0x0, 0x7f), (0xa0, 0xa3), (0xa5, 0xa5), (0xa7, 0xac), (0xae, 0xb1), (0xb4, 0xb8), (0xba, 0xbb), (0xbf, 0xd6), (0xd8, 0xff), (0x131, 0x131), (0x152, 0x153), (0x178, 0x178), (0x192, 0x192), (0x2c6, 0x2c7), (0x2d8, 0x2dd), (0x3a9, 0x3a9), (0x3c0, 0x3c0), (0x2013, 0x2014), (0x2018, 0x201a), (0x201c, 0x201e), (0x2022, 0x2022), (0x2026, 0x2026), (0x2030, 0x2030), (0x2044, 0x2044), (0x20ac, 0x20ac), (0x2122, 0x2122), (0x2202, 0x2202), (0x2206, 0x2206), (0x220f, 0x220f), (0x2211, 0x2211), (0x221a, 0x221a), (0x221e, 0x221e), (0x222b, 0x222b), (0x2248, 0x2248), (0x2260, 0x2260), (0x2264, 0x2265), (0x25ca, 0x25ca), (0xf8ff, 0xf8ff)])



add_encoding('mac_iceland', characters=CHARS_MAC_ICELAND,
             scripts={'Latn': 121, 'Grek': 2, 'Zzzz': 1, 'Zyyy': 132},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)


add_encoding('mac_latin2', characters=CHARS_MAC_CENTEURO,
             scripts={'Latn': 145, 'Zyyy': 111},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_MAC_ROMAN = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0¡¢£¥§¨©ª«¬®¯°±´µ¶·¸º»¿ÀÁÂÃÄÅÆÇÈÉÊËÌÍÎÏÑÒÓÔÕÖØÙÚÛÜßàáâãäåæçèéêëìíîïñòóôõö÷øùúûüÿıŒœŸƒˆˇ˘˙˚˛˜˝Ωπ–—‘’‚“”„†‡•…‰‹›⁄€™∂∆∏∑√∞∫≈≠≤≥◊\uf8ffﬁﬂ'


CHARS_MAC_ROMAN = charblocks([(0x0, 0x7f), (0xa0, 0xa3), (0xa5, 0xa5), (0xa7, 0xac), (0xae, 0xb1), (0xb4, 0xb8), (0xba, 0xbb), (0xbf, 0xcf), (0xd1, 0xd6), (0xd8, 0xdc), (0xdf, 0xef), (0xf1, 0xfc), (0xff, 0xff), (0x131, 0x131), (0x152, 0x153), (0x178, 0x178), (0x192, 0x192), (0x2c6, 0x2c7), (0x2d8, 0x2dd), (0x3a9, 0x3a9), (0x3c0, 0x3c0), (0x2013, 0x2014), (0x2018, 0x201a), (0x201c, 0x201e), (0x2020, 0x2022), (0x2026, 0x2026), (0x2030, 0x2030), (0x2039, 0x203a), (0x2044, 0x2044), (0x20ac, 0x20ac), (0x2122, 0x2122), (0x2202, 0x2202), (0x2206, 0x2206), (0x220f, 0x220f), (0x2211, 0x2211), (0x221a, 0x221a), (0x221e, 0x221e), (0x222b, 0x222b), (0x2248, 0x2248), (0x2260, 0x2260), (0x2264, 0x2265), (0x25ca, 0x25ca), (0xf8ff, 0xf8ff), (0xfb01, 0xfb02)])



add_encoding('mac_roman', characters=CHARS_MAC_ROMAN,
             scripts={'Latn': 117, 'Grek': 2, 'Zzzz': 1, 'Zyyy': 136},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_MAC_ROMANIAN = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0¡¢£¥§¨©ª«¬®¯°±´µ¶·¸º»¿ÀÁÂÃÄÅÇÈÉÊËÌÍÎÏÑÒÓÔÕÖÙÚÛÜßàáâãäåçèéêëìíîïñòóôõö÷ùúûüÿĂăıŒœŸƒȘșȚțˆˇ˘˙˚˛˜˝Ωπ–—‘’‚“”„†‡•…‰‹›⁄€™∂∆∏∑√∞∫≈≠≤≥◊\uf8ff'


CHARS_MAC_ROMANIAN = charblocks([(0x0, 0x7f), (0xa0, 0xa3), (0xa5, 0xa5), (0xa7, 0xac), (0xae, 0xb1), (0xb4, 0xb8), (0xba, 0xbb), (0xbf, 0xc5), (0xc7, 0xcf), (0xd1, 0xd6), (0xd9, 0xdc), (0xdf, 0xe5), (0xe7, 0xef), (0xf1, 0xf7), (0xf9, 0xfc), (0xff, 0xff), (0x102, 0x103), (0x131, 0x131), (0x152, 0x153), (0x178, 0x178), (0x192, 0x192), (0x218, 0x21b), (0x2c6, 0x2c7), (0x2d8, 0x2dd), (0x3a9, 0x3a9), (0x3c0, 0x3c0), (0x2013, 0x2014), (0x2018, 0x201a), (0x201c, 0x201e), (0x2020, 0x2022), (0x2026, 0x2026), (0x2030, 0x2030), (0x2039, 0x203a), (0x2044, 0x2044), (0x20ac, 0x20ac), (0x2122, 0x2122), (0x2202, 0x2202), (0x2206, 0x2206), (0x220f, 0x220f), (0x2211, 0x2211), (0x221a, 0x221a), (0x221e, 0x221e), (0x222b, 0x222b), (0x2248, 0x2248), (0x2260, 0x2260), (0x2264, 0x2265), (0x25ca, 0x25ca), (0xf8ff, 0xf8ff)])



add_encoding('mac_romanian', characters=CHARS_MAC_ROMANIAN,
             scripts={'Latn': 117, 'Grek': 2, 'Zzzz': 1, 'Zyyy': 136},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_MAC_TURKISH = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0¡¢£¥§¨©ª«¬®¯°±´µ¶·¸º»¿ÀÁÂÃÄÅÆÇÈÉÊËÌÍÎÏÑÒÓÔÕÖØÙÚÛÜßàáâãäåæçèéêëìíîïñòóôõö÷øùúûüÿĞğİıŒœŞşŸƒˆˇ˘˙˚˛˜˝Ωπ–—‘’‚“”„†‡•…‰™∂∆∏∑√∞∫≈≠≤≥◊\uf8a0\uf8ff'


CHARS_MAC_TURKISH = charblocks([(0x0, 0x7f), (0xa0, 0xa3), (0xa5, 0xa5), (0xa7, 0xac), (0xae, 0xb1), (0xb4, 0xb8), (0xba, 0xbb), (0xbf, 0xcf), (0xd1, 0xd6), (0xd8, 0xdc), (0xdf, 0xef), (0xf1, 0xfc), (0xff, 0xff), (0x11e, 0x11f), (0x130, 0x131), (0x152, 0x153), (0x15e, 0x15f), (0x178, 0x178), (0x192, 0x192), (0x2c6, 0x2c7), (0x2d8, 0x2dd), (0x3a9, 0x3a9), (0x3c0, 0x3c0), (0x2013, 0x2014), (0x2018, 0x201a), (0x201c, 0x201e), (0x2020, 0x2022), (0x2026, 0x2026), (0x2030, 0x2030), (0x2122, 0x2122), (0x2202, 0x2202), (0x2206, 0x2206), (0x220f, 0x220f), (0x2211, 0x2211), (0x221a, 0x221a), (0x221e, 0x221e), (0x222b, 0x222b), (0x2248, 0x2248), (0x2260, 0x2260), (0x2264, 0x2265), (0x25ca, 0x25ca), (0xf8a0, 0xf8a0), (0xf8ff, 0xf8ff)])



add_encoding('mac_turkish', characters=CHARS_MAC_TURKISH,
             scripts={'Latn': 120, 'Grek': 2, 'Zzzz': 2, 'Zyyy': 132},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_PALMOS = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\x81\x9b\x9d\x9e\xa0¡¢£¤¥¦§¨©ª«¬\xad®¯°±²³´µ¶·¸¹º»¼½¾¿ÀÁÂÃÄÅÆÇÈÉÊËÌÍÎÏÐÑÒÓÔÕÖ×ØÙÚÛÜÝÞßàáâãäåæçèéêëìíîïðñòóôõö÷øùúûüýþÿŒœŠšŸƒˆ˜–—‘’‚“”„†‡•…‰‹€™♠♣♥♦'


CHARS_PALMOS = charblocks([(0x0, 0x7f), (0x81, 0x81), (0x9b, 0x9b), (0x9d, 0x9e), (0xa0, 0xff), (0x152, 0x153), (0x160, 0x161), (0x178, 0x178), (0x192, 0x192), (0x2c6, 0x2c6), (0x2dc, 0x2dc), (0x2013, 0x2014), (0x2018, 0x201a), (0x201c, 0x201e), (0x2020, 0x2022), (0x2026, 0x2026), (0x2030, 0x2030), (0x2039, 0x2039), (0x20ac, 0x20ac), (0x2122, 0x2122), (0x2660, 0x2660), (0x2663, 0x2663), (0x2665, 0x2666)])



add_encoding('palmos', characters=CHARS_PALMOS,
             scripts={'Latn': 122, 'Zyyy': 134},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)

# CHARS_PTCP154 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\xa0§©«¬®°¶·»ЁІЈЎАБВГДЕЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯабвгдежзийклмнопрстуфхцчшщъыьэюяёіјўҒғҖҗҘҙҚқҜҝҠҡҢңҪҫҮүҰұҲҳҶҷҸҹҺһӘәӢӣӨөӮӯ–—‘’“”„•…№'


CHARS_PTCP154 = charblocks([(0x0, 0x7f), (0xa0, 0xa0), (0xa7, 0xa7), (0xa9, 0xa9), (0xab, 0xac), (0xae, 0xae), (0xb0, 0xb0), (0xb6, 0xb7), (0xbb, 0xbb), (0x401, 0x401), (0x406, 0x406), (0x408, 0x408), (0x40e, 0x40e), (0x410, 0x44f), (0x451, 0x451), (0x456, 0x456), (0x458, 0x458), (0x45e, 0x45e), (0x492, 0x493), (0x496, 0x49d), (0x4a0, 0x4a3), (0x4aa, 0x4ab), (0x4ae, 0x4b3), (0x4b6, 0x4bb), (0x4d8, 0x4d9), (0x4e2, 0x4e3), (0x4e8, 0x4e9), (0x4ee, 0x4ef), (0x2013, 0x2014), (0x2018, 0x2019), (0x201c, 0x201e), (0x2022, 0x2022), (0x2026, 0x2026), (0x2116, 0x2116)])



add_encoding('ptcp154', characters=CHARS_PTCP154,
             scripts={'Latn': 52, 'Zyyy': 96, 'Cyrl': 108},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)


add_encoding('shift_jis_2004', characters=None,
             scripts={'Latn': 342, 'Grek': 53, 'Kana': 205, 'Zyyy': 558, 'Zinh': 32, 'Hani': 10054, 'Cyrl': 66, 'Hira': 89},
             multibyte=True, fixed=False, unicode=False,
             charsize=None, maxbits=16)


add_encoding('shift_jisx0213', characters=None,
             scripts={'Latn': 342, 'Grek': 53, 'Kana': 205, 'Zyyy': 558, 'Zinh': 32, 'Hani': 10044, 'Cyrl': 66, 'Hira': 89},
             multibyte=True, fixed=False, unicode=False,
             charsize=None, maxbits=16)

# CHARS_TIS_620 = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9a\x9b\x9c\x9d\x9e\x9fกขฃคฅฆงจฉชซฌญฎฏฐฑฒณดตถทธนบปผฝพฟภมยรฤลฦวศษสหฬอฮฯะัาำิีึืฺุู฿เแโใไๅๆ็่้๊๋์ํ๎๏๐๑๒๓๔๕๖๗๘๙๚๛'


CHARS_TIS_620 = charblocks([(0x0, 0x9f), (0xe01, 0xe3a), (0xe3f, 0xe5b)])



add_encoding('tis_620', characters=CHARS_TIS_620,
             scripts={'Latn': 52, 'Thai': 86, 'Zyyy': 109},
             multibyte=False, fixed=True, unicode=False,
             charsize=1, maxbits=8)


add_encoding('utf_16', characters=UNICODE,
             scripts=UNICODE_SCRIPTS,
             multibyte=True, fixed=False, unicode=True,
             charsize=None, maxbits=48)


add_encoding('utf_16_be', characters=UNICODE,
             scripts=UNICODE_SCRIPTS,
             multibyte=True, fixed=False, unicode=True,
             charsize=None, maxbits=32)


add_encoding('utf_16_le', characters=UNICODE,
             scripts=UNICODE_SCRIPTS,
             multibyte=True, fixed=False, unicode=True,
             charsize=None, maxbits=32)


add_encoding('utf_32', characters=UNICODE,
             scripts=UNICODE_SCRIPTS,
             multibyte=True, fixed=True, unicode=True,
             charsize=8, maxbits=64)


add_encoding('utf_32_be', characters=UNICODE,
             scripts=UNICODE_SCRIPTS,
             multibyte=True, fixed=True, unicode=True,
             charsize=4, maxbits=32)


add_encoding('utf_32_le', characters=UNICODE,
             scripts=UNICODE_SCRIPTS,
             multibyte=True, fixed=True, unicode=True,
             charsize=4, maxbits=32)


add_encoding('utf_7', characters=UNICODE,
             scripts=UNICODE_SCRIPTS,
             multibyte=True, fixed=False, unicode=True,
             charsize=None, maxbits=64)


add_encoding('utf_8', characters=UNICODE,
             scripts=UNICODE_SCRIPTS,
             multibyte=True, fixed=False, unicode=True,
             charsize=None, maxbits=32)


add_encoding('utf_8_sig', characters=UNICODE,
             scripts=UNICODE_SCRIPTS,
             multibyte=True, fixed=False, unicode=True,
             charsize=None, maxbits=56)

